/* ::::::::::: [ PAGE SPECS START ] ::::::::::: */
/* ::::::::::: [ PAGE SPECS START ] ::::::::::: */

var pageSpecsSource = {
			source:"wireframe", // "wireframe", "admin"
			footerclass:"none",  //pageSpecs.footerclass = "none", "content", "under-backdrop", "under-form", "over-page" 
			footertop:0,  //  default = 0
			footerradius:0, //  default = 0
			footercolor:"#000000", 
			footeropacity:0,
			footerrgba:"rgba(0,0,0,0)",
			footerstrokecolor:"#000000", // "#000000"
			footerstroke:0, // 0
			footerlink:"#FFFFFF", 
			footertext:"#FFFFFF", 
			footerrules:"Promotion Rules",
			footerprivacy:"Privacy Policy",
			footerp:"none",
			footerptext:11, // defautl = 11
			footerlegaltext:11, // defautl = 11
			boomrulesprivacy:true,
			boomrights:true,
			footerplaycode:"none", //"none", "footer", "content"
			footerplaysize:11, //
			footerplaycolor:"#FFFFFF", //
			footerplayprefix:"Game ID: ", //
			preloadcanvas:true,
			preloadhextop:"#ffffff", //"#ffffff"
			preloadhexbg:"#cbcbcb", // "#cbcbcb"
	};

var footerSource = "<div class='brandFooter text-center'> \
						<ul id='footerLegal' class='list-inline center-block'> \
							<li><a class='footerRules rulesLink' href='#'>Promotion Rules</a></li> \
							<li><a class='footerPrivacy privacyLink' href='#'>Privacy Policy</a></li> \
						</ul> \
						<p id='cataboomRights'>&#169; CataBoom, LLC. All Rights Reserved.</p> \
					</div>"; 

/* ::::::::::: [ PAGE SPECS END ] ::::::::::: */
/* ::::::::::: [ PAGE SPECS END ] ::::::::::: */

var isIframe = false;
var gameEngaged = false;
var isLivePage = true;

// TODO: Not happy, bob
if(!version.canvas && cb?.utils?.ensureSynchronousConfig)
	cb.utils.ensureSynchronousConfig().then(stylePages)
else {
	stylePages();
}

function stylePages(){
	
	if (top.location != self.location) { 
		isIframe = true;
	}
	
	var thisUrl = window.location.href;
	var isFile = thisUrl.match( /file:/ );
	 if(isFile == "file:"){
		 isLivePage = false;
		 exitlinks[0].playcode = ( new Date().getTime() ) + "-LOCALDEMO";
	 }
	
		switch(pageid) {
			case "index":
				styleIndex();
				break;
			default:
				pageid = pageid;
		}
	
	addPageSpecs();
	
}

/* ::::::::::: [ STYLE INDEX PAGE START] ::::::::::: */
/* ::::::::::: [ STYLE INDEX PAGE START] ::::::::::: */

	function styleIndex(){
		// FORMAT INDEX FOR iFRAME....
		if (isIframe == true) { // format index for iFrame
			$('body').css('overflow', 'hidden');
			$('.brandFooter').css('padding', '0.3em 0px 0.3em 0px');
			$('.brandFooter').css('height', '2em');
			$('.brandFooter').css('font-size', '1em');
			$('#cataboomRights').css('display', 'none');
		}
		if(isIframe == true && version.scenario == "banner" ){
			$('#indexMasthead').css('display', 'none');
			if(version.canvas[0] == 514 && version.canvas[1]== 428 ){
			   $('body').css('background-size', '300px 250px');
			   }
			if(version.canvas[0] == 728 && version.canvas[1]== 90 ){
			   $('body').css('background-size', '728px 90px');
			   }
			$('#promoRow').addClass('collapse');
		}
		showPromos();
		
	}

	function showPromos(){
			
		var promoList = ["#arryBlankSpace", "#promo01", "#promo02", "#promo03", "#promo04"];
		var promoImgList = ["#arryBlankSpace", "#promo01img", "#promo02img", "#promo03img", "#promo04img"];
		
		if(promoCount == 0){
			$('#promoRow').addClass('collapse');
		}
		
		for (i = 0; i < promoList.length; i++) {
			//HIDE PROMOS THAT ARE NOT OFFERED
			if(i > promoCount){
				$(promoList[i]).hide();
			}
			if(i <= promoCount && i != 0){
				var thisImage = imgpath + "promoicon0" + i + ".png";
				$(promoImgList[i]).attr("src", thisImage);
			}
		}
		
		var thisImage = imgpath + "promoicon01.png";
		$("#promo01img").attr("src", thisImage);
				
	}

/* ::::::::::: [ STYLE INDEX PAGE END] ::::::::::: */
/* ::::::::::: [ STYLE INDEX PAGE END] ::::::::::: */


/* ::::::::::: [ ENGAGEMENT START ] ::::::::::: */
/* ::::::::::: [ ENGAGEMENT START ] ::::::::::: */

function logEngagement(note){
	
	if(gameEngaged && gameEngaged == false){ gameEngaged = true }
	
	if(exitlinks[0].engagepath != "none"){
				
        var engagespecs = {
                event:note,
            };
		
		$.ajax({
                type: "POST",
                url: exitlinks[0].engagepath,
                data: JSON.stringify(engagespecs),
                contentType: "application/json; charset=utf-8",
                error: function(response){
                    console.log('logEngagement error ' + note);
                }
            });
		
	} // end if none
	
} // end logEngagement()

/* ::::::::::: [ ENGAGEMENT END ] ::::::::::: */
/* ::::::::::: [ ENGAGEMENT END ] ::::::::::: */

/* ::::::::::: [ FOOTER SPECS START ] ::::::::::: */
/* ::::::::::: [ FOOTER SPECS START ] ::::::::::: */

function addPageSpecs(){
	
	if( pageid == "index"){
		
		var thisSpecJson = pageSpecs["footerclass"];
		
		if(thisSpecJson == "specsdata"){
				pageSpecs = pageSpecsSource;
			} // end if thisSpecJson

		if(pageSpecs.footerclass != "none"){
			formatFooter();
		} else{
			$(".rulesLink").prop("href", exitlinks[0].rules).prop("target", "_blank");
			$(".privacyLink").prop("href", exitlinks[0].privacy).prop("target", "_blank");
		}
	   
	   } // end 

	if( pageid == "pin" || pageid == "message" || pageid == "fulfillment" || pageid == "overview" ){
		//$('body').append( footerSource);
		var thisSpecJson = pageSpecs["footerclass"];
		if(thisSpecJson == "specsdata"){
				pageSpecs = pageSpecsSource;
			} // end if thisSpecJson
		if(pageSpecs.footerclass != "none"){
			$('body').append( footerSource);
			formatFooter();
		}
	}
	
	if( pageid == "index" ||  pageid == "pin" || pageid == "message" || pageid == "fulfillment" || pageid == "overview" ){
		formatPlayCode();
		formatFooterTweaks();
	}
	
	if(pageid == "preview"){
		$(".brandFooter").hide();
	}
	
}


function formatFooter() {
  if(!pageSpecs.footermaxwidth
    || (pageSpecs.source == "admin"
      && pageSpecs.footerclass == "content"
      && pageSpecs.footermaxwidth == 640
      && pageSpecs.footermaxwidth != version.canvas[0])) {
    pageSpecs.footermaxwidth = version.canvas[0]; // patch for default footer max width if not equal to 640px.
  }

	var thisFooterClass = pageSpecs.footerclass;
	var thisMaxWidth = pageSpecs.footermaxwidth + "px";
	var thisTop = pageSpecs.footertop + "px auto auto auto";
	var thisBgColor = pageSpecs.footerrgba;
	var thisLinkColor = pageSpecs.footerlink;
	var thisTxtColor = pageSpecs.footertext;
	var thisRadius = pageSpecs.footerradius + "px";
	var thisBorder = pageSpecs.footerstroke + "px solid " + pageSpecs.footerstrokecolor;

	
	$('.brandFooter').css('background-color', thisBgColor);
	$('.brandFooter a').css('color', thisLinkColor);
	$('.brandFooter').css('color', thisTxtColor);
	$('.brandFooter').css('border-radius', thisRadius);
	$(".footerRules").html(pageSpecs.footerrules);
	$(".footerPrivacy").html(pageSpecs.footerprivacy);
	$('.brandFooter').css('display', 'block');
	
	if(pageSpecs.footerstroke != 0){
	   $('.brandFooter').css('border', thisBorder);
	   }
	
		switch(thisFooterClass) {  // "none", "page", "content"
			case "under-backdrop":
				$(".brandFooter").addClass("navbar-fixed-bottom");
				$('body').css('padding-bottom', "3em");
				$('.brandFooter').css('z-index', "1030");
				break;
			case "under-form":
				$(".brandFooter").addClass("navbar-fixed-bottom");
				$('body').css('padding-bottom', "3em");
				$('.brandFooter').css('z-index', "1051");
				break;
			case "over-page":
				$(".brandFooter").addClass("navbar-fixed-bottom");
				$('body').css('padding-bottom', "3em");
				$('.brandFooter').css('z-index', "1060");
				break;
			case "content":
				$(".brandFooter").removeClass("navbar-fixed-bottom");
				$('.brandFooter').css('max-width', thisMaxWidth);
				$('.brandFooter').css('margin', thisTop);
				$('.brandFooter').css('z-index', "auto");
				break;
			default:
				$(".brandFooter").hide();
				$('body').css('padding-bottom', "3em");
				
		}
	
		if(pageSpecs.boomrights == false){
		   $("#cataboomRights").hide();
		}
	
		if(pageSpecs.boomrulesprivacy == false){
		   $("#footerLegal").hide();
		}
	
		var thisLegalTxtSize = pageSpecs.footerlegaltext + "px";
		$('.brandFooter').css('font-size', thisLegalTxtSize);

		if(pageSpecs.footerp != "none"){
			$( ".brandFooter" ).prepend( "<p id='brandFooterP'>" + pageSpecs.footerp + "</p>" );
			$('.brandFooter').css('height', "auto");
			var thisTextSize = pageSpecs.footerptext + "px";
			$('#brandFooterP').css('font-size', thisTextSize);
		   } // end if pageSpecs
	
	// BANNER SPECIFIC TWEAKS ...	
	if(isIframe == true){
			$('.brandFooter').removeClass('navbar-fixed-bottom');
			$('.brandFooter').css('margin-top', '-2em');
		}
	
	$(".rulesLink").prop("href", exitlinks[0].rules).prop("target", "_blank");
	$(".privacyLink").prop("href", exitlinks[0].privacy).prop("target", "_blank");

   } // end formatFooter()

/* ::::::::::: [ FOOTER SPECS END ] ::::::::::: */
/* ::::::::::: [ FOOTER SPECS END ] ::::::::::: */

/* ::::::::::: [ PLAYCODE SPECS START ] ::::::::::: */
/* ::::::::::: [ PLAYCODE SPECS START ] ::::::::::: */

function formatPlayCode(){
	
	var thisPlayCodeSize = pageSpecs.footerplaysize  + "px";
	var thisPlayCodeColor = pageSpecs.footerplaycolor;
	var thisPlayCodePrefix = pageSpecs.footerplayprefix;
	var thisPlayCode = thisPlayCodePrefix + exitlinks[0].playcode;
	
	if(exitlinks[0].playcode == "none" || exitlinks[0].playcode.length < 1){ // turn off if no playcode
		pageSpecs.footerplaycode = "none";
	}

	if(pageSpecs.footerplaycode == "footer" && pageid != "pin"){
		$( ".brandFooter" ).append( "<p id='playcodeFooter'>" + thisPlayCode + "</p>" );
		$( "#playcodeFooter" ).css('font-size', thisPlayCodeSize);
		$( "#playcodeFooter" ).css('color', thisPlayCodeColor);
	}
	
	if(pageSpecs.footerplaycode == "content" && pageid != "pin"){
		
		switch(pageid) {
			case "index":
				$( ".gameColumn" ).append( "<p id='playcodeContent' class='text-center'>" + thisPlayCode + "</p>" );
				break;
			case "fulfillment":
				$( ".messageColumn" ).append( "<p id='playcodeContent' class='text-center'>" + thisPlayCode + "</p>" );
				break;
			case "message":
				$( "#messageRow" ).append( "<p id='playcodeContent' class='text-center'>" + thisPlayCode + "</p>" );
				break;
			default:
				pageid = pageid;
		}

		$( "#playcodeContent" ).css('font-size', thisPlayCodeSize);
		$( "#playcodeContent" ).css('color', thisPlayCodeColor);
	}

} // end formatPlayCode()

/* ::::::::::: [ PLAYCODE SPECS END ] ::::::::::: */
/* ::::::::::: [ PLAYCODE SPECS END ] ::::::::::: */

function formatFooterTweaks(){
	// banner scenario fixes
	if(version.scenario == "banner" && isIframe == true && pageid == "index" && pageSpecs.footerclass != "none"   ){ 
		$("#brandFooterP").remove();
		$("#cataboomRights").remove();
		$("#playcodeFooter").remove();
		if(pageSpecs.footerclass == "content"){
			$(".brandFooter").addClass("navbar-fixed-bottom");
			$('.brandFooter').css('max-width', "100%");
		}
   	} // end banner scenario
	
	// padding page bottom fixes
	if(pageSpecs.footerclass != "content" && pageSpecs.footerclass != "none" && isIframe == false && version.scenario != "banner"  ){
		var thisHeight = $(".brandFooter").outerHeight();
		var thisSpec = thisHeight + "px"
		$('body').css('padding-bottom', thisSpec);
	} // end if thisFooterclass
}

	
