// JavaScript Document

		//83, 296, 510
	var manifest = [
		{src: "btn01off.png", class:"button", x:360, y:360, z:0, slot:0, choice:"1", width:720, height:720},
		{src: "btn02off.png", class:"button", x:360, y:360, z:0, slot:1, choice:"2", width:720, height:720},
		{src: "btn03off.png", class:"button", x:360, y:360, z:0, slot:2, choice:"3", width:720, height:720},
		{src: "btn01on.png", class:"icon", x:360, y:360, z:0, slot:0, width:720, height:720},
		{src: "btn02on.png", class:"icon", x:360, y:360, z:0, slot:1, width:720, height:720},
		{src: "btn03on.png", class:"icon", x:360, y:360, z:0, slot:2, width:720, height:720},
		{src: "prompt_watch.png", class:"prompt", x:360, y:360, width:720, height:720, offset:80},
		{src: "prompt_play.png", class:"prompt", x:360, y:360, width:720, height:720, offset:80},
		{src: "round01.png", class:"round", x:360, y:360, width:720, height:720},
		{src: "overlay.png", class:"skin", x:360, y:360, width:720, height:720},
		{src: "markers.png", class:"marker", width:60, height:60},
		{src: "taptracking.png", class:"tap", width:80, height:80},
		{src: "btn_exit00.png", class:"exit", x:360, y:360, width:720, height:720, pause:1000, time:500, linkto:"replace"},
		{src: "btn_exit01.png", class:"exit", x:360, y:360, width:720, height:720, pause:1000, time:500, linkto:"replace"},
		{src: "btn_exit02.png", class:"exit", x:360, y:360, width:720, height:720, pause:1000, time:500, linkto:"replace"},
		{src: "btn_exit03.png", class:"exit", x:360, y:360, width:720, height:720, pause:1000, time:500, linkto:"replace"},
		{src: "btn_exit04.png", class:"exit", x:360, y:360, width:720, height:720, pause:1000, time:500, linkto:"replace"},
		{src:"numbers_timer.png", class:"timer", x:680, y:676, offset:80, time:15, track:true},
		{src:"numbers_score.png", class:"score", x:40, y:660, offset:50,},
		{src:"numbers_scorefinal.png", class:"score", x:360, y:360, offset:50, },
	];

var gamespecs = {
	width:720, height:720,
	scenecount:1, scoremin:1, exitsparks:true, zerosparks:false, memory:true,
};

/*
gamespecs.scoremin = minimum score to count as a win
*/

var cyclespecs = {
	zclass:"single", // length00-length10 NOT zero indexed !!!
	cylcle00:[0,1,2,0,1,2], length00:4, time00:15, class00:"memory", key00:"none",
	cylcle01:[0,1,2,0,1,2], length01:5, time01:15, class01:"memory", key01:"none",
	cylcle02:[0,1,2,0,1,2], length02:6, time02:15, class02:"memory", key02:"none",
	cylcle03:[0,1,2,3], length03:4, time03:15, class03:"memory", key03:"none",
	cylcle04:[0,1,2,3], length04:4, time04:15, class04:"memory", key04:"none",
	cylcle05:[0,1,2,3], length05:4, time05:15, class05:"memory", key05:"none",
	cylcle06:[0,1,2,3], length06:4, time06:15, class06:"memory", key06:"none",
	cylcle07:[0,1,2,3], length07:4, time07:15, class07:"memory", key07:"none",
	cylcle08:[0,1,2,3], length08:4, time08:15, class08:"memory", key08:"none",
	cylcle09:[0,1,2,3], length09:4, time09:15, class09:"memory", key09:"none",
	cylcle10:[0,1,2,3], length10:4, time10:15, class10:"memory", key10:"none",
};

/*
cyclespecs.zclass: "single" use the same button set for each scene, "multi" use new button set for each scene
*/

var cycleSetList = [
	// list of 11 source number sets for randomizing...
	cyclespecs.cylcle00, cyclespecs.cylcle01, cyclespecs.cylcle02, cyclespecs.cylcle03, cyclespecs.cylcle04, cyclespecs.cylcle05, 
	cyclespecs.cylcle06, cyclespecs.cylcle07, cyclespecs.cylcle08, cyclespecs.cylcle09, cyclespecs.cylcle10, 
	
];

var cycleLengthList = [
	// list of 1length of set to randomize, NOT zero index value,
	cyclespecs.length00, cyclespecs.length01, cyclespecs.length02, cyclespecs.length03, cyclespecs.length04, cyclespecs.length05, 
	cyclespecs.length06, cyclespecs.length07, cyclespecs.length08, cyclespecs.length09, cyclespecs.length10, 
	
];

var cycleTimeList = [
	// maximum time allowed for each cycle of play,
	cyclespecs.time00, cyclespecs.time01, cyclespecs.time02, cyclespecs.time03, cyclespecs.time04, cyclespecs.time05, 
	cyclespecs.time06, cyclespecs.time07, cyclespecs.time08, cyclespecs.time09, cyclespecs.time10, 
];

var cycleClassList = [	cyclespecs.class00, cyclespecs.class01, cyclespecs.class02, cyclespecs.class03, cyclespecs.class04, cyclespecs.class05, 
	cyclespecs.class06, cyclespecs.class07, cyclespecs.class08, cyclespecs.class09, cyclespecs.class10, 
];

var cycletweens = {
	intropause:1750, pausein:500, timein:333, tweenin:createjs.Ease.sineOut, 
	pauseout:333, timeout:333, tweenout:createjs.Ease.sineIn, 
}
	
	/*
	cycletweens.intropause = first long pause before cycle start
	cycletweens.pausein =  pause before ico tween in
	cycletweens.timein =  time for ico tween in
	cycletweens.tweenin =  tween type for ico tween in
	cycletweens.pauseout =  pause before tween out
	cycletweens.timeout =  time for ico tween out
	cycletweens.tweenout =  tween type for ico tween in
	
	*/

var keyList = [
	cyclespecs.key00, cyclespecs.key01, cyclespecs.key02, cyclespecs.key03, cyclespecs.key04, cyclespecs.key05, 
	cyclespecs.key06, cyclespecs.key07, cyclespecs.key08, cyclespecs.key09, cyclespecs.key10, 
];

var markerspecs = {
	offset:60, introalpha:0, count:3,
	markerx:[360, 380, 230, 291, 350, 410, 472, 531, 591, 630 ],
	markery:[ 660, 660, 660, 660, 660, 660, 660, 660, 660, 660, ] 
}

/*
	markerx:[51, 112, 170, 230, 291, 350, 410, 472, 531, 591, ],
	markery:[ 430, 430, 430, 430, 430, 430, 430, 430, 430, 430, ] 
	
markerspecs.offset
markerspecs.introalpha  = 0, make higher to qa
markerspecs.count = number of markers, not Zero-indexed
markerspecs.markerx[indexNmbr] = x positions 
markerspecs.markery[indexNmbr] = y positions 

*/

 var btnspecs = {
	timein:15, timeout:333, wait:333, tweenin:createjs.Ease.sineIn, tweenout:createjs.Ease.sineOut,
}
/*
	btnspecs.timein = time tween in for btn user click
	btnspecs.timeout = time tween out for btn user click
	btnspecs.wait = time to display at full opacity for click
	btnspecs.tweenin = time tween in for btn user click
	btnspecs.tweenout = time tween out for btn user click
*/

var exitspecs = {
	scaleinx:1, scaleiny:1, alphain:0, offsetx:0, offsety:60, tweenin:createjs.Ease.sineOut, 
}
/*

exitspecs.scaleinx
exitspecs.scaleiny
exitspecs.alphain
exitspecs.offsetx
exitspecs.offsety
exitspecs.tweenin

*/

var roundspecs = {
	scaleinx:1, scaleiny:1, alphain:0, offsetinx:0, offsetiny:60, pausein:500, timein:500, tweenin:createjs.Ease.sineOut, 
	scaleoutx:1, scaleouty:1, alphaout:0, offsetoutx:0, offsetouty:-60, pauseout:0, timeout:500, tweenout:createjs.Ease.sineOut, 
}

/*

	roundspecs.scaleinx
	roundspecs.scaleiny
	roundspecs.alphain
	roundspecs.offsetinx
	roundspecs.offsetiny
	roundspecs.pausein
	roundspecs.timein
	roundspecs.tweenin
	
	roundspecs.scaleoutx
	roundspecs.scaleouty
	roundspecs.alphaout
	roundspecs.offsetoutx
	roundspecs.offsetouty
	roundspecs.pauseout
	roundspecs.timeout
	roundspecs.tweenout

*/

var promptspecs = {
	scaleinx:1, scaleiny:1, alphain:0, offsetinx:0, offsetiny:0, pausein:0, timein:333, tweenin:createjs.Ease.sineIn, 
	scaleoutx:1, scaleouty:1, alphaout:0, offsetoutx:0, offsetouty:0, pauseout:0, timeout:333, tweenout:createjs.Ease.sineOut, 
}

/*

	promptspecs.scaleinx
	promptspecs.scaleiny
	promptspecs.alphain
	promptspecs.offsetinx
	promptspecs.offsetiny
	promptspecs.pausein
	promptspecs.timein
	promptspecs.tweenin
	
	promptspecs.scaleoutx
	promptspecs.scaleouty
	promptspecs.alphaout
	promptspecs.offsetoutx
	promptspecs.offsetouty
	promptspecs.pauseout
	promptspecs.timeout
	promptspecs.tweenout

*/

var tapspecs = {
	offset:80, introalpha:0, count:10, pauseout:333,
	x:360, y:673,
}

/*
	
tapspecs.offset
tapspecs.introalpha  = 0, make higher to qa
tapspecs.count = number of taps, not Zero-indexed

*/

