// ADD FORM CSS CLASSES TO PAGE HEADER ....
// ( sample css cited after addFormStyles() function )

var gameBkgPng = "gameboard.png";  // "gameboard.png" || "cta.png" for scratch-off
var isWireframe = true;
var videoWireframe = false;
var sourceApi = 0;

var isAdminUrl = window.location.href.indexOf("/admin/");

var bntValidIcon = "<span class='glyphicon glyphicon-ok'></span>&nbsp;";

if(isAdminUrl > -1 ){
	isWireframe = false;
}

if(isWireframe == false){sourceApi = adminoptions.wireframe_api}; // get api admin
if(isWireframe == true){sourceApi = version.api}; // get api wireframe

if(pageId = "index" ){
//if(formOptions.form_channel == "entry" || formOptions.form_channel == "entry-mobile" ){
	videoWireframe = version.video; // flag video usage
}

// modallogin patch overwrite 
if(
		formOptions.form_class == "entry" && 
		isWireframe == true && 
		formsetup[0].modallogin == "none"
	){
		// modallogin patch overwrite 	
		formOptions.form_channel = "none"; 
		console.log(
			"class=" + formOptions.form_class + " wireframe=" +isWireframe + 
			" 2016ModalLogin=" + formsetup[0].modallogin
		)
   }


setDeviceInfo();

function addFormStyles(){
	
	// process #hex color to rgba color
	var thisBkgHex = formOptions.form_background;
	var thisOpacity = formOptions.background_opacity;
	var opacityValue = thisOpacity / 100;
	  
	thisBkgHex = thisBkgHex.replace('#','');
    var redColor = parseInt(thisBkgHex.substring(0,2), 16);
    var greenColor = parseInt(thisBkgHex.substring(2,4), 16);
    var blueColor = parseInt(thisBkgHex.substring(4,6), 16);

	var thisRgba = 'rgba('+ redColor +','+ greenColor  +','+ blueColor +','+ opacityValue +')';
	// background-color:" + formOptions.form_background + " !important;\
	
	// process backdrop from hex to RGBA	
	var thisBackdropgHex = formOptions.form_backdrop || "#000000"; // fallback #000000 for API < 12
	var thisBackdropOpacity = Number(formOptions.backdrop_opacity) / 100 ;

	thisBackdropgHex = thisBackdropgHex.replace('#','');
    var redColorBackdrop = parseInt(thisBackdropgHex.substring(0,2), 16);
    var greenColorBackdrop = parseInt(thisBackdropgHex.substring(2,4), 16);
    var blueColorBackdrop = parseInt(thisBackdropgHex.substring(4,6), 16);

	var thisRgbaBackdrop = 'rgba('+ redColorBackdrop +','+ greenColorBackdrop   +','+ blueColorBackdrop +','+ thisBackdropOpacity +')';
	
	var thisChannel = formOptions.form_channel;
	$('#formStyles').html("");
	
	// css for exit form
	var cssBoomForm = 
		".boomForm { \
			background-color:" + thisRgba + " !important;\
			border:" + formOptions.border_width + "px solid " + formOptions.form_border + " !important;\
			border-radius:" + formOptions.border_radius + "px !important;\
			max-width:" + formOptions.form_width + "px !important;\
			color:" + formOptions.form_text + " !important;\
		 }";
	if(thisChannel == "exit"){
		$('#formStyles').append( cssBoomForm );
	}
	if(thisChannel != "exit" && isWireframe == false ){
		$('#formStyles').append( cssBoomForm );
	}
	
	// css for entry form
	var cssEntryForm = 
		"#entrySkinDiv { \
			background-color:" + thisRgba + " !important;\
			border:" + formOptions.border_width + "px solid " + formOptions.form_border + " !important;\
			border-radius:" + formOptions.border_radius + "px !important;\
			color:" + formOptions.form_text + " !important;\
			max-width:90%;\
			min-width:324px !important;\
			padding:1em 0px 1em 0px;\
			position: absolute;\
			margin-top:" +  formOptions.mobile_top +"px;\
			left: 50%;\
			margin-right: -50%;\
			transform: translateX(-50%);\
			z-index:1052 !important;\
			display:block;\
		 } \
		#validationForm{min-width:305px !;}";
	
	// media query for entry margin top	 
	var cssEntryMargin =
		 "@media all and (min-width: 768px) { \
			#entryFormDiv{padding-left:0px;min-width:305px} \
		 }\
		 @media all and (min-width: 992px) { \
			#entrySkinDiv{\
					max-width:958px !important;\
					margin-top:" + formOptions.form_top + "px;\
				} \
		}";
		 
	if(thisChannel == "entry" && isWireframe == true){
		$('#formStyles').append( cssEntryForm );
		$('#formStyles').append( cssEntryMargin );
		var thisBannerPng = imgpath + "entry_title_left.png";
		$('#bigImg').prop("src", thisBannerPng );
	}
	
	// css for entry-mobile form
	// background-color:" + formOptions.form_background + " !important;\
	var cssMobileForm = 
		"#entrySkinDiv { \
			background-color:" + thisRgba + " !important;\
			border:" + formOptions.border_width + "px solid " + formOptions.form_border + " !important;\
			border-radius:" + formOptions.border_radius + "px !important;\
			color:" + formOptions.form_text + " !important;\
			max-width:" + formOptions.form_width + "px !important;\
			padding:1em 1em 1em 1em;\
			position: absolute;\
			margin-top:" + formOptions.mobile_top + "px;\
			left: 50%;\
			margin-right: -50%;\
			transform: translateX(-50%);\
			z-index:1052 !important;\
			display:block;\
		 }";
		 //top: 2em;\
		 //  margin-top:" + formOptions.form_top + "px;\
		 
	var cssEntryMobileMargin =
		 "@media all and (min-width: 992px) { \
			#entrySkinDiv{\
					position: absolute;\
					margin-top:" + formOptions.form_top + "px;\
				}\
		}";
		
		//top:" + formOptions.form_top + "px;\
	
	if(thisChannel == "entry-mobile" && isWireframe == true){
		$('#formStyles').append( cssMobileForm );
		$('#formStyles').append( cssEntryMobileMargin ); // ADD .entryForm CLASS ( VAR =  cssEntryForm)
		// clean out wrapper elements
		$('#entryLeftDiv').addClass('collapse');
		$('#entryFormDiv').removeClass();
		$('#smallImage').removeClass('visible-xs');
	}
	
	var cssFieldInputs = 
	".boomForm input, .boomForm textarea, .boomForm select{ \
			border-color:" + formOptions.field_border + " !important; \
			background-color:" + formOptions.field_bkg + " !important; \
			color:" + formOptions.field_text + " !important; \
		}";
	$('#formStyles').append( cssFieldInputs );
	
	var cssPlachoder = 
		".boomForm ::-webkit-input-placeholder { color:" + formOptions.field_cta + " !important; } \
		.boomForm ::-moz-placeholder { color:" + formOptions.field_cta + " !important; }\
		.boomForm ::-ms-placeholder { color:" + formOptions.field_cta + " !important; }";
	$('#formStyles').append( cssPlachoder );
	
	var cssBtnDisabled =
	".boomForm button:disabled { \
		border-color:" + formOptions.btn_border + " !important; \
		background-color:" + formOptions.btn_bkg + " !important;  \
		color:" + formOptions.btn_text + " !important;  \
	}";
	$('#formStyles').append( cssBtnDisabled );
	
	var cssBtnSuccess = 
	".boomForm button { \
		border-color:" + formOptions.btn_border + " !important; \
		background-color:" + formOptions.btn_bkg + " !important; \
		color:" + formOptions.btn_text + " !important; \
	}";
	$('#formStyles').append(cssBtnSuccess);
	
	var cssBtnNoThanks = 
	"#button-exitlink, #button-goback { \
		border-color:" + formOptions.btn_border + " !important; \
		background-color:" + formOptions.btn_bkg + " !important; \
		color:" + formOptions.btn_text + " !important; \
	}";
	$('#formStyles').append(cssBtnNoThanks);
	
	var cssBtnFake = 
	".boomForm .btn { \
		border-color:" + formOptions.btn_border + " !important; \
		background-color:" + formOptions.btn_bkg + " !important; \
		color:" + formOptions.btn_text + " !important; \
	}";
	$('#formStyles').append(cssBtnFake);
	
	var cssOkay = 
	".boomForm button .glyphicon-ok{ \
		color:" + formOptions.btn_text  + " !important; \
	}";
	$('#formStyles').append(cssOkay);
	
	var cssErrors =  
	".text-danger{ \
		color:" + formOptions.field_error + " !important; \
	} \
	.has-error input{ \
		color:" + formOptions.field_error + " !important; \
		border-color:" + formOptions.field_error + "  !important; \
	}";
	$('#formStyles').append(cssErrors);
	
	var cssLabel = 
	".boomForm .inputLabel{color:" + formOptions.form_text + ";}";
	$('#formStyles').append(cssLabel);
	
	var cssGeoLabel = 
	".boomForm .geoLabel{color:" + formOptions.form_text + ";}";
	$('#formStyles').append(cssLabel);
	
	var cssRemove = 
	".boomForm .glyphicon-remove{color:" + formOptions.field_error + " !important;}";
	$('#formStyles').append(cssRemove);
	
	var cssHrLine = 
	".boomForm hr{ border-color:" + formOptions.form_border + " !important; }"; 
	$('#formStyles').append(cssHrLine);
	
	var cssOkay = 
	".boomForm .glyphicon-ok{ color:" + formOptions.form_border + " !important; }";
	$('#formStyles').append( cssOkay );
	
	var cssFeedbackOkay = 
	".has-feedback .glyphicon-ok{ color:" + formOptions.success_icon + " !important; }";
	$('#formStyles').append( cssFeedbackOkay );
	
	var cssLink = 
	".boomForm a{ color:" + formOptions.form_link + " !important; }";
	$('#formStyles').append( cssLink );
	
	var cssTerms = 
	"#termsDiv { \
			border-color:" + formOptions.form_border + "  !important;\
			background-color:" + formOptions.form_background + " !important;\
			border-width:" + formOptions.border_width + "px !important;\
			border-radius:" + formOptions.border_radius + "px !important;\
			color:" + formOptions.form_text + " !important;\
		 }";
	$('#formStyles').append( cssTerms );
	
	var cssTermsCloseBtn = 
	"#btnCloseTerms { \
			border-color:" + formOptions.field_error + "  !important;\
			background-color:" + formOptions.field_error + " !important;\
			color:" + formOptions.form_background + " !important;\
		 }";
	$('#formStyles').append( cssTermsCloseBtn );
	
	if(thisChannel == "entry" || thisChannel == "entry-mobile"){
			var cssModalBackdrop =
			"#modalBackdrop { \
				background-color:" + thisRgbaBackdrop + " !important;  \
			}";
			$('#formStyles').append( cssModalBackdrop );
	}

	
	var thisUrl = document.location.href;
	var adminIndexOf = thisUrl.indexOf("/admin/");
	
	// set checkmark icon used/not-used in valid buttons
	if(formOptions.btn_valid){
		switch(formOptions.btn_valid) {
		case "glyphicon-ok":
			bntValidIcon = "<span class='glyphicon glyphicon-ok'></span>&nbsp;";
			break;
		case "collapse":
			bntValidIcon = "<span class='collapse'></span>";
			break;
		default:
			bntValidIcon = "<span class='glyphicon glyphicon-ok'></span>&nbsp;";
		}
	}
	
	if(formOptions.form_class== "entry" && adminIndexOf == -1){
		addModalEntryUI();
		setEntryUi();
	}
	
}

function addModalEntryUI(){
	// STYLE FOR #validationForm && .entryForm
	
	var cssBoomBkg = 
		".gameCanvas{ background-image:url(" + imgpath + gameBkgPng + ") !important; }";

	$('#formStyles').append( cssBoomBkg );
	
	setEntryUi();
	
}

function setEntryUi(){
		//GAME DIV
		var teaserPath = "url(" + imgpath + "teaser.png)";
		$('#boomCanvas').css('background-image', teaserPath);
		$('#boomCanvas').fadeIn();
		if(formOptions.backdrop_opacity != 0){
			$('#modalBackdrop').show();
		}
}

function setCanvasUi(){
		//GAME DIV
		$('html,body').scrollTop(0); //go to top of page
		$('#modalBackdrop').remove();
		if(isWireframe == true){
			$('.entryForm').remove(); //hide entry form
		}
		if(videoWireframe == false)	{
			var bkgPath = "url(" + imgpath +  gameBkgPng + ")";
			$('#boomCanvas').css('background-image', bkgPath );
			$('#boomCanvas').addClass('gameCanvas');
		}
		$('#boomCanvas').show();
		//init(); //go to mechanic.js
		var thisChannel = formOptions.form_channel;
		if(thisChannel == "none" && isWireframe ==  true){
			// init no modal entry
			//$( "canvas" ).delay( 300 ).queue(init);
			showCanvasOrVideo();
		}
		if(thisChannel != "none" && isWireframe ==  true){
			showCanvasOrVideo();
		}
		
}

function showCanvasOrVideo(){

	switch(videoWireframe) {
				case true:
					initVideo();
					break;
				default:
					init();		
					//$( "canvas" ).delay( 500 ).queue(init);
			} // end switch

}

function closeEntryUi(){
		runGameClass();
	
		if(geoTimer != false){
			clearInterval(geoTimer);
			geoTimer = false;
		}
	
		$('html,body').scrollTop(0); //go to top of page
		$('#modalBackdrop').remove();
		if(isWireframe == true){
			$('.entryForm').remove(); //hide entry form
		}
		//FINAL BUTTON TO CLOSE MODAL...
	
}

/* ::::::::::: [ CANVAS UI BEGIN ] ::::::::::: */
/* ::::::::::: [ CANVAS UI BEGIN ] ::::::::::: */
/* ::::::::::: [ CANVAS UI BEGIN ] ::::::::::: */

function runGameClass(){
		//reset viewport meta 
		$('meta[name=viewport]').attr('content', 'width=device-width, initial-scale=1, maximum-scale=2, minimum-scale=0.5, user-scalable=yes');
		
		switch(gameclass) {
			case "local":
				showCanvas();//local or demo not no server comm
				break;
			case "demo":
				showCanvas(); //local or demo not no server comm
				break;
			case "test":
				runAjax(); //run when test
				break;
			case "live":
				runAjax(); //run when live
				break;
			default:
				runAjax(); //run when live
				
		}//end switch
	
	}
	
	function runAjax(){
		//IF MODAL FORM USED ...
		if(formsetup[0].modallogin != "none"){
		//AJAX CALL START
				$.ajax({
					type: "POST",
					url: formsetup[0].acceptpath,
					data: $('#validationForm').serialize(),
					success: function(msg){
						if ("winlevel" in msg) { winlevel = msg.winlevel; }
						if ("referral" in msg) { 
							exitlinks[0].referral = msg.referral; 
							doSocialLinks(); //in social.js
							showReferral(); //in social.js
						}
						showCanvas();
					},
					error: function(response){
						var data = JSON.parse(response.responseText);
						if ("error" in data) {
							if (data.error == "coppa") {
								window.location.replace(formsetup[0].coppapath); // see build 14 for previous ajax
							}
							else {
								if ("url" in data) {
									  window.location.href = data.url;
								} else {  alert("Error: " + response.text); } //end if/else  // end error func
							}
						}
					}
				}); //end ajax
		//END AJAX CALL
		} else{ showCanvas(); } //end if else
	
	} // end runAjax()
	
	function runAjaxUrl(){
		
		var thisPath;
		var thisExit = $('#button-url').data('url');
		//var thisExit = $('#button-submit').data('url');
		
		switch(pageid) {
			case "index":
				if( formsetup[0].acceptpath ){ thisPath = formsetup[0].acceptpath };
				break;
			case "fulfillment":
				if(formsetup[0].fulfillpath){ thisPath = formsetup[0].fulfillpath };
				break;
			default:
				if( formsetup[0].acceptpath ){ thisPath = formsetup[0].acceptpath };
		}

		if(gameclass != "demo"){
				//AJAX CALL START
				$.ajax({
					type: "POST",
					url: formsetup[0].acceptpath,
					data: $('#validationForm').serialize(),
					success: function(msg){
						window.location.replace(thisExit);
					},
					error: function(response){
						var data = JSON.parse(response.responseText);
						if ("url" in data) {
							  var errorUrl = data.url; //window.location.href = data.url;
							  window.location.replace(errorUrl);
						} else {  alert("Error: " + response.text); } //end if/else  // end error func
					}
				}); 
				//END AJAX CALL
			} else {
				window.location.replace(thisExit);
			}// end gameclass if/else
		
	} //  end runAjaxUrl()
	
	function showCanvas() {
    const iFrameMessage = {message: 'cb_navigate', page: 'game'};
    window.top.postMessage(iFrameMessage, '*');
    if('parentIFrame' in window) {
      window.parentIFrame.sendMessage(iFrameMessage);
    }
    else {
      // Bit of defensive coding; with no reg form, this code runs right away.
      // Could it be before the iFrameResizer initializes? ¯\_(ツ)_/¯
      window.iFrameResizer = {
        onReady: () => window.parentIFrame.sendMessage(iFrameMessage)
      };
    }

		if(geoTimer != false){
			clearInterval(geoTimer);
			geoTimer = false;
		}
		
		if(formsetup[0].modallogin != "none" && isWireframe == true){
			$('#modalBackdrop').remove();
			$('.entryForm').remove(); //hide entry form
		}
		$("html, body").scrollTop(); //go to top of page for game
		if(coppaChecked){
			//go to coppa message
			$('#boomCanvas').hide();
			window.location.replace(formsetup[0].coppapath); 
		} else {
			$('#boomCanvas').hide();
			if(videoWireframe == false){
				$('#boomCanvas').addClass('gameCanvas');
			}
			$('#boomCanvas').fadeIn();
			//init(); //go to mechanic.js
			showCanvasOrVideo();
		}
	}
	
/* ::::::::::: [ CANVAS UI  END ] ::::::::::: */
/* ::::::::::: [ CANVAS UI  END ] ::::::::::: */
/* ::::::::::: [ CANVAS UI  END ] ::::::::::: */

/* :::::::::: [PRELOAD START ] ::::::::::: */
/* :::::::::: [PRELOAD START ] ::::::::::: */
/* :::::::::: [PRELOAD START ] ::::::::::: */

var hasPreload = true;

if(pageSpecs.footerclass != "specsdata"){
	hasPreload = pageSpecs.preloadcanvas;
}

function addPreload(){
	
	var colorTop = "#ffffff"; // formOptions.field_bkg
	var colorBg = "#cbcbcb"; // formOptions.success_icon
	var preloadTarget = ".gameColumn" // .videoCanvasWrapper
	var isThisVideo = version.video;
	
	if(pageSpecs.footerclass != "specsdata"){
		colorTop = pageSpecs.preloadhextop; // formOptions.field_bkg
		colorBg = pageSpecs.preloadhexbg; // formOptions.success_icon
	}
	
	if(isThisVideo == true){
		preloadTarget = ".videoCanvasWrapper"
	}
	
	var cssLoader =
		".loader180 { \
			border: 16px solid " + colorBg + "; \
			border-top: 16px solid " + colorTop + "; \
		}";
	$('#formStyles').append( cssLoader );
	
	var thisWidth = version.canvas[0] || 480;
	var thisHeight = version.canvas[1] || 480;
	
	if(hasPreload == true){
		var thisLoader = "<div id='boomLoader' width='" + thisWidth + "' height='" + thisHeight + "'><div class='loader180'></div></div>";
		$(preloadTarget).prepend(thisLoader);
	}
	
	setPreloadSize();
}

function removePreload(){
	if(hasPreload == true){
		$( "#boomLoader" ).remove();
	}
}

$(window).resize(function() {
    setPreloadSize();
});

function setPreloadSize(){
	if(pageid == "index"){
		var thisTopMultiply = 0.3;
		var canvasHeight = $('#boomCanvas').height();

		if(canvasHeight < 90){ // tweak for leaderboard Preview and Video preview
			thisTopMultiply = 0.15;
		}

		var thisMarginTop = Math.round(canvasHeight * thisTopMultiply);
		var thisWidthHeight = Math.round(canvasHeight * .4);
		var thisBorder = Math.round(canvasHeight * .05);
		$(".loader180").css('margin-top', thisMarginTop ).css('width', thisWidthHeight ).css('height', thisWidthHeight ).css('border-width', thisBorder);
	}	
}


/* :::::::::: [PRELOAD END ] ::::::::::: */
/* :::::::::: [PRELOAD END ] ::::::::::: */
/* :::::::::: [PRELOAD END ] ::::::::::: */

/* ::::::::::: [ SET DEVICE INFO START ] ::::::::::: */
/* ::::::::::: [ SET DEVICE INFO START ] ::::::::::: */
/* ::::::::::: [ SET DEVICE INFO START ] ::::::::::: */

function setDeviceInfo(){
	// check device type...
			if(createjs.BrowserDetect.isIOS){ deviceClass = "ios" }
			if(createjs.BrowserDetect.isAndroid){ deviceClass = "android" }
			if(createjs.BrowserDetect.isWindowPhone ){ deviceClass = "iemobile" }
			if(createjs.BrowserDetect.isBlackberry ){ deviceClass = "blackberry" }
			 
			if(createjs.BrowserDetect.isFirefox){ browserClass = "firefox" }
			if(createjs.BrowserDetect.isChrome){ browserClass = "chrome" }
			
			var thisUrl = document.location.href;
			var urlCheck = thisUrl.indexOf("?dc=");
			
			/* // UPDATE URL WITH deviceClass && browserClass
			if(urlCheck < 0 && isWireframe == true){
				document.location.href = thisUrl + "?dc=" + deviceClass + "&bc=" + browserClass;
			}
			*/
			
}

/* ::::::::::: [ SET DEVICE INFO END ] ::::::::::: */
/* ::::::::::: [ SET DEVICE INFO END ] ::::::::::: */
/* ::::::::::: [ SET DEVICE INFO END ] ::::::::::: */



/* :::::::::::: [ DEMO PLACEHOLDER JSON INDEX PAGE ] :::::::::::::: */
/* :::::::::::: [ DEMO PLACEHOLDER JSON INDEX PAGE ] :::::::::::::: */
		var demoEntry = {
			form_channel:"none", // "entry", "entry-mobile", "none" "exit", 
			form_class:"entry", // "entry", "exit"
			modallogin:"none", 
			form_border:"#DEDEDE", // "#DEDEDE"
			form_background:"#FEFEFE", // "#FEFEFE"
			form_backdrop:"#010101",  // #010101
			form_text:"#343434", // "#343434"
			form_link:"#337AB7", // "#337AB7"
			success_icon:"#CBCBCB", // "#CBCBCB"
			field_bkg:"#FFFFFF", // "#FFFFFF"
			field_error:"#A74343", // "#A74343"
			field_cta:"#9A9A9A", // "#9A9A9A"
			field_text:"#343434", // "#343434"
			field_border:"#CDCDCD", // "#343434"
			btn_text:"#343434", // "#343434"
			btn_bkg:"#FFFFFF", // "#FFFFFF"
			btn_border:"#CDCDCD", // "#343434"
			btn_valid:"glyphicon-ok", // "collapse", "glyphicon-ok"
			border_width:1,
			border_radius:6,
			background_opacity:100,
			backdrop_opacity:0,
			form_width:335,
			form_top:100,
			mobile_top:100,
			reserved:{
				required_pin:"",
				player_id:"",
				primary_email:"",
				primary_phone:"",
				guess_entry:"",
				mailbouncemsg:"",
				mailbounceinline:"",
				mailbounceaccept:"Valid Email",
				mailbouncereject:"Invalid Email",
				mailbouncelatency:2000,
			},
			api_names:[],
			form_names:[],
			form_content:[
			{ // FORM ELEMENT :::::::::
				id:"name",
				type:"text",
				info:"Name Input",
				success:"Enter Name",
				fail:"Enter Name *",
				utility01:"collapse",
				required:true,
				api:false,
				playerid:false,
				primary:false,
				align:"collapse",
				ulcfilter:"user",
				mailbounce:"collapse",
				options:["collapse"],
				range:[0,1,2,3,4,5,6,7,8,9,10],
				},
			{ // FORM ELEMENT :::::::::
				id:"email",
				type:"email",
				info:"Email Input",
				success:"Enter Email",
				fail:"Enter Email *",
				utility01:"collapse",
				required:true,
				api:false,
				playerid:false,
				primary:false,
				align:"collapse",
				ulcfilter:"user",
				mailbounce:"none",
				options:["collapse"],
				range:[0,1,2,3,4,5,6,7,8,9,10],
				},
			{ // FORM ELEMENT :::::::::
				id:"button-submit",
				type:"button",
				info:"Submit Button",
				success:"Submit",
				fail:"Form Incomplete",
				utility01:"button-enter",
				required:true,
				api:false,
				playerid:false,
				primary:false,
				align:"right",
				ulcfilter:"collapse",
				mailbounce:"collapse",
				options:["collapse"],
				range:[0,1,2,3,4,5,6,7,8,9,10],
			},
		] // end formContent node
		};
		
/* :::::::::::: [ DEMO PLACEHOLDER JSON FULFILLMENT PAGE ] :::::::::::::: */
/* :::::::::::: [ DEMO PLACEHOLDER JSON FULFILLMENT PAGE ] :::::::::::::: */
		
		var demoExit = {
			form_channel:"exit", // entry, exit, none
			form_class:"exit", // "entry", "exit"
			modallogin:"none", 
			form_border:"#DEDEDE", // "#DEDEDE"
			form_background:"#FEFEFE", // "#FEFEFE"
			form_backdrop:"#010101",  // #010101
			form_text:"#343434", // "#343434"
			form_link:"#337AB7", // "#337AB7"
			success_icon:"#CBCBCB", // "#CBCBCB"
			field_bkg:"#FFFFFF", // "#FFFFFF"
			field_error:"#A74343", // "#A74343"
			field_cta:"#9A9A9A", // "#9A9A9A"
			field_text:"#343434", // "#343434"
			field_border:"#CDCDCD", // "#343434"
			btn_text:"#343434", // "#343434"
			btn_bkg:"#FFFFFF", // "#FFFFFF"
			btn_border:"#CDCDCD", // "#343434"
			btn_valid:"glyphicon-ok", // "collapse", "glyphicon-ok"
			border_width:1,
			border_radius:6,
			background_opacity:100,
			backdrop_opacity:0,
			form_width:360,
			form_top:0,
			mobile_top:0,
			reserved:{
				required_pin:"",
				player_id:"",
				primary_email:"",
				primary_phone:"",
				guess_entry:"",
				mailbouncemsg:"",
				mailbounceinline:"",
				mailbounceaccept:"Valid Email",
				mailbouncereject:"Invalid Email",
				mailbouncelatency:2000,
			},
			api_names:[],
			form_names:[],
			form_content:[
			{ // FORM ELEMENT :::::::::
				id:"name",
				type:"text",
				info:"Name Input",
				success:"Enter Name",
				fail:"Enter Name *",
				utility01:"collapse",
				required:true,
				api:false,
				playerid:false,
				primary:false,
				align:"collapse",
				ulcfilter:"user",
				mailbounce:"collapse",
				options:["collapse"],
				range:[0,1,2,3,4,5,6,7,8,9,10],
				},
			{ // FORM ELEMENT :::::::::
				id:"email",
				type:"email",
				info:"Email Input",
				success:"Enter Email",
				fail:"Enter Email *",
				utility01:"collapse",
				required:true,
				api:false,
				playerid:false,
				primary:false,
				align:"collapse",
				ulcfilter:"user",
				mailbounce:"none",
				options:["collapse"],
				range:[0,1,2,3,4,5,6,7,8,9,10],
				},
			{ // FORM ELEMENT :::::::::
				id:"button-submit",
				type:"button",
				info:"Submit Button",
				success:"Submit",
				fail:"Form Incomplete",
				utility01:"button-exit",
				required:true,
				api:false,
				playerid:false,
				primary:false,
				align:"right",
				ulcfilter:"collapse",
				mailbounce:"collapse",
				options:["collapse"],
				range:[0,1,2,3,4,5,6,7,8,9,10],
			},
		] // end formContent node
		};


		var demoGpsDeepEllum = {
			  gps_channel:"entry", // "entry", "exit"
			  gps_content:[
				  	{ // GPS NODE ...
						"id":"Common desk door",
						"index":0,
						"latitude":32.7837608,
						"longitude":-96.7813146, 
						"max_latitude":32.783982,
						"max_longitude":-96.781351,
						"range":0.0005000, // :0.0002242
					},
					{ // GPS NODE ...
						"id":"Psub front door",
						"index":1,
						"latitude":32.7835083,
						"longitude":-96.7827371, 
						"max_latitude":32.783713,
						"max_longitude":-96.782702,
						"range":0.0005000, // 0.0002077,
					},
					{ // GPS NODE ...
						"id":"Uber front door",
						"index":2,
						"latitude":32.783255,
						"longitude":-96.783325, 
						"max_latitude":32.783457,
						"max_longitude":-96.783459,
						"range":0.0005000, // 0.0002800
					},
					{ // GPS NODE ...
						"id":"Dots front door",
						"index":3,
						"latitude":32.7831498,
						"longitude":-96.7844944, 
						"max_latitude":32.783322,
						"max_longitude":-96.784572,
						"range":0.0005000, // 0.0003089, // 0.0001889
					},
					{ // GPS NODE ...
						"id":"Twisted root front door",
						"index":4,
						"latitude":32.78281,
						"longitude":-96.785401, 
						"max_latitude":32.783128,
						"max_longitude":-96.785522,
						"range":0.0005000, // 0.0003530,
					},
					{ // GPS NODE ...
						"id":"Buzzbrew Front Door",
						"index":6,
						"latitude":32.783314,
						"longitude":-96.78311, 
						"max_latitude":90.0000,
						"max_longitude":0.0000,
						"range":0.0005,
					},
			  ]
		  };
/*
		 var demoGpsFormNode = 			
			 { // FORM ELEMENT :::::::::
						id:"geo-checkbox",
						type:"geo-checkbox-open",
						info:"GPS Submission (Checkbox Required, any Device)",
						success:"I understand I am sharing GPS my location",
						fail:"Finding GPS...",
						utility01:"Please Use a GPS Enabled Device",
						required:true,
						api:false,
						playerid:false,
						align:"collapse",
						options:["collapse"], // "32.7837326|-96.7811817|0.0005",
						range:[0,1,2,3,4,5,6,7,8,9,10],
					},
					*/
/* :::::::::: [ SAMPLE CSS ] :::::::::::: */
	/*
	<style id="formStyles">
    
	.boomForm{
		border-color:#DEDEDE !important;
		background-color:#FEFEFE !important;
		color:#343434 !important;
	}
	
	.boomForm input, .boomForm textarea, .boomForm select{
		border-color:#DEDEDE !important;
		background-color:#FFFFFF !important;
		color:#343434 !important;
	}
	
	.boomForm ::-webkit-input-placeholder {
		color:#9A9A9A !important;
	}
	
	.boomForm ::-moz-placeholder {
		color:#9A9A9A !important;
	}
	
	.boomForm ::-ms-placeholder {
		color:#9A9A9A !important;
	}
	
	.boomForm button:disabled {
		border-color:#DEDEDE !important;
		background-color:#FFFFFF !important;
		color:#DEDEDE !important;
	}
	
	.boomForm button {
		border-color:#DEDEDE !important;
		background-color:#FFFFFF !important;
		color:#343434 !important;
	}
	
	.boomForm button .glyphicon-ok{
		color:#343434 !important;
	}
	
	.text-danger{
		color:#A74343 !important;
	}
	
	.has-error input{
		color:#A74343 !important;
		border-color:#A74343  !important;
	}
	
	.boomForm .glyphicon-remove{
		color:#A74343 !important;
	}

	.boomForm hr{
		border-color:#DEDEDE !important;
	}
	
	.boomForm .glyphicon-ok{
		color:#CBCBCB !important;
	}
	
	.boomForm a{
		color:#337AB7 !important;
	}

    </style>*/
