/* :::::::::: [ SCREENING FUNCTIONS VARIABLES BEGIN ] :::::::::: */
/* :::::::::: [ SCREENING FUNCTIONS VARIABLES BEGIN ] :::::::::: */
	
var focusIndex = ""; 
var focusId =  "";
var focusValue = "";
var focusDiv =  "";
var focusSpan =  "";
	
//VARS FOR DATES
var modalDay = 0;
var modalMonth = 0;
var modalYear = 0;
var coppaChecked = false;

var pairEvent = "input"; // "input" || "change keyup paste blur" = IE10 & 11 patch
	
function setFocus(idName) {
	var specialChars = '\t !"#$%&\'()*+,./:;<=>?@[]^`{|}~';
	var escapedId = idName.split('\\').join('\\\\'); // Handle backslashes first
	specialChars.split('').map(function(a){escapedId = escapedId.split(a).join('\\' + a)});
	focusId = "#" + escapedId;
	focusValue = $(focusId).val();
	focusIndex = $(focusId).data("index");
	focusDiv = focusId + "Div";
	focusSpan = focusId + "Span";
}

function setFocusUlc(idName) {
	setFocus(idName);
	
	var filterType = $(focusId).data("ulc");

	switch(filterType) {
		case "uppercase":
			focusValue = focusValue.toUpperCase();
			$(focusId).val(focusValue);
			break;
		case "lowercase":
			focusValue = focusValue.toLowerCase();
			$(focusId).val(focusValue);
			break;
		case "mixedcase":
			var mixedValue = filterCaptilaize(focusValue);
			$(focusId).val(mixedValue);
			break;
		default:
			filterType; // user, collapse, or Nan
	}
}

doPairPatchIE();

function doPairPatchIE(){

	var ua = window.navigator.userAgent;
    var msie = ua.indexOf("MSIE ");

    if (msie > 0 || !!navigator.userAgent.match(/Trident.*rv\:11\./) ){
        pairEvent = "keyup paste";
    }
} // doPairPatchIE()

	
	/* :::::::::: [ SCREENING FUNCTIONS VARIABLES END ] :::::::::: */
	/* :::::::::: [ SCREENING FUNCTIONS VARIABLES END ] :::::::::: */
	
	/* :::::::::: [ SCREENING FUNCTIONS BEGIN ] :::::::::: */
	/* :::::::::: [ SCREENING FUNCTIONS BEGIN ] :::::::::: */
	
	/* :::::::::: [ BIRTHDAY FUNCTIONS BEGIN ] :::::::::: */
	/* :::::::::: [ BIRTHDAY FUNCTIONS BEGIN ] :::::::::: */
	
	/* :::::: [ BIRTHDAY CHECKBOX BEGIN ] :::::: */
	/* :::::: [ BIRTHDAY CHECKBOX BEGIN ] :::::: */
	$(".checkboxBday").change(function(event){
	  	thisFocus = $(this).attr('id');
		setFocus(thisFocus);
		screenCheckBday()
	});
	
	function screenCheckBday(){
		var boxChecked = $( focusId )[0].checked; //gives true or false
		var checkRequired = $( focusId ).prop('required');
		var dataSuccess = $( focusId ).data("success");
		var dataFail = $( focusId ).data("fail"); 
		if(boxChecked == true && checkRequired){
			$(focusSpan).html(dataSuccess);
			$(focusSpan).removeClass('text-danger');
			validList[focusIndex] = true;
		}
		if (boxChecked == false && checkRequired){
			$(focusSpan).html(dataFail);
			$(focusSpan).addClass('text-danger');
			validList[focusIndex] = false;
		};
		
		if(boxChecked == true){
			$( focusId ).val(true);
		} else {
			$( focusId ).val(false);
		}
		checkValid();
		
	}
	
	/* :::::: [ BIRTHDAY CHECKBOX END ] :::::: */
	/* :::::: [ BIRTHDAY CHECKBOX END ] :::::: */
	
	/* :::::: [ BIRTHDAY INPUT BEGIN ] :::::: */
	/* :::::: [ BIRTHDAY INPUT BEGIN ] :::::: */
	$('.screenBday').on("input", function(event) { // INPUT FIELDS
		thisFocus = $(this).attr('id');
		setFocus(thisFocus);
		screenBday();
	});

	/* :::::: [ BIRTHDAY SELECT BEGIN ] :::::: */
	/* :::::: [ BIRTHDAY SELECT BEGIN ] :::::: */
	$('.screenBdaySelect').change(function(){ // DROPDOWN FIELDS
		thisFocus = $(this).attr('id');
		setFocus(thisFocus);
		screenBday();
	});
	
	
	function screenBday(){
		
		var thisDateType = $(focusId).data("date");
		var thisLength = focusValue;
		var maxString = $(focusId).attr("max");
		var thisMax = parseInt(maxString);
		
		switch(thisDateType) {
			case "month":
				if(focusValue > 12){
					$(focusId).val("");
					$('#month option:first').prop('selected', true);
					modalMonth = 0;
				} else {
					modalMonth = focusValue;
				}
				break;
			case "day":
				if(focusValue > 31){
					$(focusId).val("");
					$('#day option:first').prop('selected', true);
					modalDay = 0;
				} else {
					modalDay = focusValue;
				};
				break;
			case "year":
				if(thisLength > thisMax){
					$(focusId).val("");
					$('#year option:first').prop('selected', true);
					modalYear = 0;
					}else {
					modalYear = focusValue;
				};
				break;
			default:
				focusValue = focusValue;
		}
		
		isAgeValid();
		
	}
	
	function isAgeValid(){
		//console.log("Month:" + modalMonth + " day:" + modalDay + " year:" + modalYear);
		
		var ageMin = formsetup[0].agemin;
		var mydate = new Date();
		mydate.setFullYear(modalYear, modalMonth-1, modalDay);
	
		var currdate = new Date();
		currdate.setFullYear(currdate.getFullYear() - ageMin);
		
		var validDateMath = currdate - mydate;
		var coppaType = formsetup[0].coppapath; // 'none' or http://link
		
		var qualifiedAge = false;
		
		if ((currdate - mydate) < 0){
			qualifiedAge = false;
			console.log("LESS THAN ZERO - UNDER AGE");
		} else {
			qualifiedAge = true;
			console.log("GREATER THAN ZERO - AGE QUALIFIED");
		}
		
		var thisDate = new Date();
		var thisYear = thisDate.getFullYear();
		var qualifyingYear = thisYear - ageMin; 
		
		if(modalYear < 1896 || modalYear > qualifyingYear ){
			qualifiedAge = false;	
		}
		console.log("qualifiedAge:" + qualifiedAge);
		
		//UPDATE BDAY ELEMENT UI NOTICES
		if ( $(focusId).is(":valid") ) {
			showBdaySuccess();
		} else {
			showBdayFail();
		}
		
		//console.log("mydate: " + mydate);
		//console.log("currdate: " + currdate);
		//console.log(" validDateMath: " + validDateMath);
		
		var validScore = 0;
		var feedbackSuccess = $('#feedback-bday').data("success");
		var feedbackFail = $('#feedback-bday').data("fail");
		var feedbackUtilityA = $('#feedback-bday').data("utility-a");
		
		if ( $("#month").is(":valid") ) {validScore += 1};
		if ( $("#day").is(":valid") ) {validScore += 1};
		if ( $("#year").is(":valid") ) {validScore += 1};
		
		/* ::::::::: [ BDAY  SELECT CONDITIONS START ] ::::::::::: */
		if ( modalMonth == 0 || modalDay == 0 || modalYear == 0 || modalYear < 1895 ){
			validScore = 0;
			$('#feedback-bday').html(feedbackFail);
			$('#feedback-bday').addClass("text-danger");
		}
		
		if(focusValue == 0){
			validList[focusIndex] = false;
		}
		/* ::::::::: [ BDAY  SELECT CONDITIONS END ] ::::::::::: */
		
		 if(validScore == 3 && qualifiedAge){
			$('#feedback-bday').html(feedbackSuccess);
			$('#feedback-bday').removeClass("text-danger");
			//validList[focusIndex] = true;
			//checkValid();
		}
		if(validScore == 3 && qualifiedAge != true) {
			switch(coppaType) {
				case "none":
					//no coppa under age
					//$('#feedback-bday').html(feedbackFail + " -underage");
					$('#feedback-bday').html(feedbackUtilityA);
					$('#feedback-bday').addClass("text-danger");
					validList[focusIndex] = false;
					$('#coppacheck').val('coppa Okay'); // add response to coppa input field
					//console.log('standard display response'+ ' #coppacheck=coppa Okay');
					break;
				default:
					// coppa under age
					//$('#feedback-bday').html(feedbackFail + " -coppa-break");
					$('#feedback-bday').html(feedbackUtilityA);
					$('#feedback-bday').removeClass("text-danger");
					$('#coppacheck').val('Not Valid'); // add response to coppa input field
					//console.log('coppa compliance display response' + ' #coppacheck=Not Valid');
			}  // end coppaType switch
			//$('#feedback-bday').html(feedbackFail + " -coppa-break");
			//$('#feedback-bday').addClass("text-danger");
			//validList[focusIndex] = false;
			//checkValid();
		}
		
		checkValid();
		
	}
	
	function showBdaySuccess(){
		$(focusDiv).removeClass('has-error');
		$(focusSpan).removeClass('glyphicon glyphicon-remove');
		$(focusId).prop('aria-describedby', 'inputSuccess2Status');
		$(focusSpan).addClass('glyphicon glyphicon-ok');
		validList[focusIndex] = true;
	}
	
	function showBdayFail(){
		$(focusDiv).addClass('has-error');
			$(focusId).prop('aria-describedby', 'inputError2Status');
			var errorNote = $(focusId).data('fail');
			$(focusId).attr("placeholder", errorNote)
			$(focusSpan).removeClass('glyphicon glyphicon-ok');
			$(focusSpan).addClass('glyphicon glyphicon-remove');
			validList[focusIndex] = false;
	}
	
	/* :::::: [ BIRTHDAY INPUT & SELECT END ] :::::: */
	/* :::::: [ BIRTHDAY INPUT & SELECT END ] :::::: */
	
	/* :::::::::: [ BIRTHDAY FUNCTIONS END ] :::::::::: */
	/* :::::::::: [ BIRTHDAY FUNCTIONS END ] :::::::::: */
	
	/* :::::::::: [ TEXT INPUT BEGIN ] :::::::::: */
	
	$('.screenInput').on("input", function(event) {
		thisFocus = $(this).attr('id');
		setFocusUlc(thisFocus);
		screenText();
	});
	
	function screenText(){
		if ( $(focusId).is(":valid") ) {
			$(focusDiv).removeClass('has-error');
			$(focusSpan).removeClass('glyphicon glyphicon-remove');
			$(focusId).prop('aria-describedby', 'inputSuccess2Status');
			$(focusSpan).addClass('glyphicon glyphicon-ok');
			validList[focusIndex] = true;
		} else {
			$(focusDiv).addClass('has-error');
			$(focusId).prop('aria-describedby', 'inputError2Status');
			var errorNote = $(focusId).data('fail');
			$(focusId).attr("placeholder", errorNote)
			$(focusSpan).removeClass('glyphicon glyphicon-ok');
			$(focusSpan).addClass('glyphicon glyphicon-remove');
			validList[focusIndex] = false;
		}
		checkValid();
		
	}
	
	/* :::::::::: [ TEXT INPUT END ] :::::::::: */

	/* :::::::::: [ TEXT INPUT BEGIN ] :::::::::: */
	
	$('.screenEmailLc').on("input", function(event) {
		thisFocus = $(this).attr('id');
		setFocusUlc(thisFocus);
		screenEmailLc();
	});
	
	function screenEmailLc(){
		var thisValue = $(focusId).val();
		var thisFilter = thisValue.toLocaleLowerCase();
		$(focusId).val(thisFilter);
		
		if ( $(focusId).is(":valid") ) {
			$(focusDiv).removeClass('has-error');
			$(focusSpan).removeClass('glyphicon glyphicon-remove');
			$(focusId).prop('aria-describedby', 'inputSuccess2Status');
			$(focusSpan).addClass('glyphicon glyphicon-ok');
			validList[focusIndex] = true;
		} else {
			$(focusDiv).addClass('has-error');
			$(focusId).prop('aria-describedby', 'inputError2Status');
			var errorNote = $(focusId).data('fail');
			$(focusId).attr("placeholder", errorNote)
			$(focusSpan).removeClass('glyphicon glyphicon-ok');
			$(focusSpan).addClass('glyphicon glyphicon-remove');
			validList[focusIndex] = false;
		}
		checkValid();
		
	}
	
	/* :::::::::: [ TEXT INPUT END ] :::::::::: */
	
	/* :::::::::: [ TEXT INPUT W/ LABEL BEGIN ] :::::::::: */
	
	$('.screenLabel').on("input", function(event) {
		thisFocus = $(this).attr('id');
		setFocusUlc(thisFocus);
		screenLabel();
	});
	
	function screenLabel(){
		
		var labelTarget = $(focusId).data('label');
		var labelSuccess = $(focusId).data('success');
		var labelFail = $(focusId).data('fail');
		
		if ( $(focusId).is(":valid") ) {
			$(focusDiv).removeClass('has-error');
			$(focusSpan).removeClass('glyphicon glyphicon-remove');
			$(focusId).prop('aria-describedby', 'inputSuccess2Status');
			$(focusSpan).addClass('glyphicon glyphicon-ok');
			$(labelTarget).html(labelSuccess);
			$(labelTarget).removeClass('text-danger'); // label change
			validList[focusIndex] = true;
		} else {
			$(focusDiv).addClass('has-error');
			$(focusId).prop('aria-describedby', 'inputError2Status');
			var errorNote = $(focusId).data('fail');
			$(focusId).attr("placeholder", errorNote)
			$(focusSpan).removeClass('glyphicon glyphicon-ok');
			$(focusSpan).addClass('glyphicon glyphicon-remove');
			$(labelTarget).html(labelFail)
			$(labelTarget).addClass('text-danger');
			validList[focusIndex] = false;
		}
		checkValid();
		
	}
	
	/* :::::::::: [TEXT INPUT W/ LABEL END ] :::::::::: */
	/* :::::::::: [ TEXT-MAX INPUT BEGIN ] :::::::::: */
	
	$('.screenInputMax').on("input", function(event) {
		thisFocus = $(this).attr('id');
		setFocusUlc(thisFocus);
		screenTextMax();
	});
	
	function screenTextMax(){
		
		var stringLength = $(focusId).attr('maxlength');
		var maxLength = parseInt(stringLength);
		var thisValue = $(focusId).val();
		
		if ( maxLength == thisValue.length ) {
			$(focusDiv).removeClass('has-error');
			$(focusSpan).removeClass('glyphicon glyphicon-remove');
			$(focusId).prop('aria-describedby', 'inputSuccess2Status');
			$(focusSpan).addClass('glyphicon glyphicon-ok');
			validList[focusIndex] = true;
		} else {
			$(focusDiv).addClass('has-error');
			$(focusId).prop('aria-describedby', 'inputError2Status');
			$(focusSpan).removeClass('glyphicon glyphicon-ok');
			$(focusSpan).addClass('glyphicon glyphicon-remove');
			validList[focusIndex] = false;
		}
		checkValid();	
		
	}
	
	/* :::::::::: [ TEXT-MAX INPUT END ] :::::::::: */

/* :::::::::: [ TEXT INPUT W/ LABEL BEGIN ] :::::::::: */
	
	$('.screenRange').on("input", function(event) {
		thisFocus = $(this).attr('id');
		setFocus(thisFocus);
		screenRange();
	});
	
	function screenRange(){
		
		var labelTarget = $(focusId).data('label');
		var labelSuccess = $(focusId).data('success');
		var labelFail = $(focusId).data('fail');
		var minTarget = Number( $(focusId).data('min') );
		var thisValue = Number(focusValue);
		var thisBreak = $(focusId).data('break');
		
		//if ( $(focusId).is(":valid") ) {
		if ( thisValue > minTarget  ) {
			$(focusDiv).removeClass('has-error');
			$(focusSpan).removeClass('glyphicon glyphicon-remove');
			$(focusId).prop('aria-describedby', 'inputSuccess2Status');
			$(focusSpan).addClass('glyphicon glyphicon-ok');
			$(labelTarget).html(labelSuccess + thisBreak + thisValue);
			$(labelTarget).removeClass('text-danger'); // label change
			validList[focusIndex] = true;
		} else {
			$(focusDiv).addClass('has-error');
			$(focusId).prop('aria-describedby', 'inputError2Status');
			var errorNote = $(focusId).data('fail');
			$(focusId).attr("placeholder", errorNote)
			$(focusSpan).removeClass('glyphicon glyphicon-ok');
			$(focusSpan).addClass('glyphicon glyphicon-remove');
			$(labelTarget).html(labelFail + thisBreak + thisValue)
			$(labelTarget).addClass('text-danger');
			validList[focusIndex] = false;
		}
		checkValid();
		
	}
	
	/* :::::::::: [TEXT INPUT W/ LABEL END ] :::::::::: */
	/* :::::::::: [ TEXT-MAX INPUT BEGIN ] :::::::::: */
	
	$('.screenNumberMax').on("input", function(event) {
		thisFocus = $(this).attr('id');
		setFocus(thisFocus);
		screenNumberMax();
	});
	
	function screenNumberMax(){
		
		var stringLength = $(focusId).attr('maxlength');
		var maxLength = parseInt(stringLength);
		var thisValue = $(focusId).val();
		
		var filterValue = thisValue.replace(/[^0-9\.]/g,'');
		$( focusId  ).val( filterValue );
		
		if ( maxLength == filterValue.length ) {
			$(focusDiv).removeClass('has-error');
			$(focusSpan).removeClass('glyphicon glyphicon-remove');
			$(focusId).prop('aria-describedby', 'inputSuccess2Status');
			$(focusSpan).addClass('glyphicon glyphicon-ok');
			validList[focusIndex] = true;
		} else {
			$(focusDiv).addClass('has-error');
			$(focusId).prop('aria-describedby', 'inputError2Status');
			$(focusSpan).removeClass('glyphicon glyphicon-ok');
			$(focusSpan).addClass('glyphicon glyphicon-remove');
			validList[focusIndex] = false;
		}
		checkValid();	
		
		if( ctatext[0].hasOwnProperty('ctaentry') ){
			ctatext[0].ctaentry = filterValue;
		}
		
	}
	
	/* :::::::::: [ TEXT-MAX INPUT END ] :::::::::: */
	
	/* :::::::::: [PROMO-CODE INPUT BEGIN ] :::::::::: */
	$('.screenPromoCode').on("input", function(event) {
		thisFocus = $(this).attr('id');
		setFocusUlc(thisFocus);
		screenPromoCode();
	});
	
	function screenPromoCode(){
		
		var sourceValue = $(focusId).val();
		var sourceCode = $(focusId).data("code");
		
		var thisValue = sourceValue.toLowerCase();
		var thisCode = sourceCode.toLowerCase();
		
		if ( thisValue == thisCode) {
			$(focusDiv).removeClass('has-error');
			$(focusSpan).removeClass('glyphicon glyphicon-remove');
			$(focusId).prop('aria-describedby', 'inputSuccess2Status');
			$(focusSpan).addClass('glyphicon glyphicon-ok');
			validList[focusIndex] = true;
		} else {
			$(focusDiv).addClass('has-error');
			$(focusId).prop('aria-describedby', 'inputError2Status');
			var errorNote = $(focusId).data('fail');
			$(focusId).attr("placeholder", errorNote)
			$(focusSpan).removeClass('glyphicon glyphicon-ok');
			$(focusSpan).addClass('glyphicon glyphicon-remove');
			validList[focusIndex] = false;
		}
		checkValid();
		
	}
	/* :::::::::: [PROMO-CODE INPUT END ] :::::::::: */
	
	/* :::::::::: [ PHONE INPUT BEGIN ] :::::::::: */
	/* :::::::::: [ PHONE INPUT BEGIN ] :::::::::: */
	
	$('.screenPhone').on("keyup paste", function(event) {
		thisFocus = $(this).attr('id');
		setFocus(thisFocus);
		screenPhone();
	});
	
	function screenPhone(){
	  
	  var formatedNumber = "";
	  var phoneEntered = false;
	  var checkRequired = $( focusId ).prop('required');
	  
	  /* :::::::::: [ FORMATTING BEGIN ] :::::::::::: */
	  var thisValue = focusValue;
	  var valueLength = thisValue.length;
	  var regexTen = /^\(?([0-9]{3})\)?[-]?([0-9]{3})[-]?([0-9]{4})$/;

		if (valueLength == 4) {
			var regexFour = /^\(?([0-9]{3})\)?[-]?([0-9]{1})$/
			var formatFour = formatedNumber = thisValue.replace(regexFour, "$1-$2");
		}
		
		if (valueLength == 8) {
			var regexEight = /^\(?([0-9]{3})\)?[-]?([0-9]{3})[-]?([0-9]{1})$/;
			var formatEight = formatedNumber = thisValue.replace(regexEight, "$1-$2-$3");
		}

		if (regexTen.test(thisValue) && thisValue.length > 8) {
			var formatTen = formatedNumber = thisValue.replace(regexTen, "$1-$2-$3");
			phoneEntered = true;
		}
		
		if(valueLength != 4 && valueLength != 8 && regexTen.test(thisValue) == false  ){
			var filterValue = formatedNumber = thisValue.replace(/[^0-9-]/g, "");
			phoneEntered = false;
		}
		/* :::::::::: [ FORMATTING END ] :::::::::::: */

		$(focusId).val( formatedNumber);
	 
		if ( phoneEntered == true   ) {
			$(focusDiv).removeClass('has-error');
			$(focusSpan).removeClass('glyphicon glyphicon-remove');
			$(focusId).prop('aria-describedby', 'inputSuccess2Status');
			$(focusSpan).addClass('glyphicon glyphicon-ok');
			validList[focusIndex] = true;
		} else {
			$(focusDiv).addClass('has-error');
			$(focusId).prop('aria-describedby', 'inputError2Status');
			$(focusSpan).removeClass('glyphicon glyphicon-ok');
			$(focusSpan).addClass('glyphicon glyphicon-remove');
			validList[focusIndex] = false;
		}
		
		if(checkRequired == false && valueLength == 0){
			$(focusDiv).removeClass('has-error');
			$(focusSpan).removeClass('glyphicon glyphicon-remove');
			$(focusId).prop('aria-describedby', 'inputSuccess2Status');
			$(focusSpan).removeClass('glyphicon glyphicon-ok');
		}
		
		if(checkRequired == false){
			validList[focusIndex] = true;
		}
		
		checkValid();
		
		console.log(focusId + " checkRequired" + checkRequired + " valid?" + validList[focusIndex] +
					" valueLength:" + valueLength);
		
	}
	
	/* :::::::::: [ PHONE INPUT END ] :::::::::: */
	/* :::::::::: [ PHONE INPUT END ] :::::::::: */
	
	/* :::::::::: [ ZIP INPUT BEGIN ] :::::::::: */
	/* :::::::::: [ ZIP INPUT BEGIN ] :::::::::: */
	
	$('.screenZip').on("input", function(event) {
		thisFocus = $(this).attr('id');
		setFocusUlc(thisFocus);
		screenZip();
	});
	
	function screenZip(){
		
		var thisRegion = $( focusId ).data("region");
		var zipValue = focusValue;
		
		switch(thisRegion) {
			case "unitedstates":
					zipValue.replace(/[^1-9\.]/g,'');
					$( focusId  ).val( zipValue.substr(0,5) );
					if ($(focusId).is(":valid") && zipValue.length == 5) {
						showZipSuccess();						 
					} else {
						showZipError();
					} //end defaul
				break;
			case "canada":
					var filterLetters = zipValue.replace(/[^0-9A-Za-z]/g, '');
					 var formatedZip = "";
					 for (i = 0; i < filterLetters.length; i++) { 
						if(i == 3){
							formatedZip += (" " + filterLetters[i].toString());
						} else {
							formatedZip += filterLetters[i].toString(); 
						}
					} // end for loop
					
					$(focusId).val(formatedZip);
					 var regExZip = /^[A-Za-z]\d[A-Za-z][ -]?\d[A-Za-z]\d$/;
					 if (regExZip.test(formatedZip)) {
						showZipSuccess();						 
					} else {
						showZipError();
					} //end canda
					break;
			default:
					var regExUS = /^([0-9]{5})(?:[-\s]*([0-9]{4}))?$/; // US Zip
					var regExCA = /^([A-Za-z][0-9][A-Za-z][ -]?[0-9][A-Za-z][0-9])?$/;
					if ( zipValue.match(regExUS) || zipValue.match(regExCA) ) {
						showZipSuccess();						 
					} else {
						showZipError();
					} //end default
			} //end switch
		
			if(zipValue.length < 5){
				showZipError();				
			}
			
			checkValid();
	} // end screenZip()

		function showZipSuccess(){
			$(focusDiv).removeClass('has-error');
			$(focusSpan).removeClass('glyphicon glyphicon-remove');
			$(focusId).prop('aria-describedby', 'inputSuccess2Status');
			$(focusSpan).addClass('glyphicon glyphicon-ok');
			validList[focusIndex] = true;
		}

		function showZipError(){
			$(focusDiv).addClass('has-error');
			$(focusId).prop('aria-describedby', 'inputError2Status');
			$(focusSpan).removeClass('glyphicon glyphicon-ok');
			$(focusSpan).addClass('glyphicon glyphicon-remove');
			validList[focusIndex] = false;
		}
	
	/* :::::::::: [ ZIP INPUT END ] :::::::::: */
	/* :::::::::: [ ZIP INPUT END ] :::::::::: */

	/* ::::::::: [ EMAIL PAIR CONFIRMATION BEGIN ] ::::::::: */
	/* ::::::::: [ EMAIL PAIR CONFIRMATION BEGIN ] ::::::::: */
	var emailPairIndex1 = 0;
	var emailPairIndex2 = 0;
	
	$('.screenEmailPair').on(pairEvent, function(event) {
		thisFocus = $(this).attr('id');
		setFocusUlc(thisFocus);
		emailPairIndex1 = $('#emailpair01').data("index");
		emailPairIndex2 = $('#emailpair02').data("index");
		screenEmailPair();
	});
	
	function screenEmailPair(){
		
		var mailValue00 = $('#emailpair01').val();
		var mailValue01 = $('#emailpair02').val();
		var mailValid00 = $('#emailpair01').is(":valid");
		var mailValid01 = $('#emailpair02').is(":valid");
		
		if(mailValue00 != mailValue01  ){
			//both valid, both match
			validList[emailPairIndex1] = false;
			validList[emailPairIndex2] = false;
			setFocus('emailpair01');
			emailPairError()
			setFocus('emailpair02');
			emailPairError()
		}
		
		if(mailValue00 == mailValue01 && mailValid00 && mailValid01 && mailValue00.length > 5 ){
			//both valid, both match, value > 4 characters a@a.c
			validList[emailPairIndex1] = true;
			validList[emailPairIndex2] = true;
			setFocus('emailpair01');
			emailPairSuccess();
			setFocus('emailpair02');
			emailPairSuccess();
		}
		
		checkValid();
		
	} // end screenEmailPair()
	
	function emailPairError(){
			$(focusDiv).addClass('has-error');
			$(focusId).prop('aria-describedby', 'inputError2Status');
			var errorNote = $(focusId).data('fail');
			$(focusId).attr("placeholder", errorNote)
			$(focusSpan).removeClass('glyphicon glyphicon-ok');
			$(focusSpan).addClass('glyphicon glyphicon-remove');
	}
	
	function emailPairSuccess(){
			$(focusDiv).removeClass('has-error');
			$(focusSpan).removeClass('glyphicon glyphicon-remove');
			$(focusId).prop('aria-describedby', 'inputSuccess2Status');
			$(focusSpan).addClass('glyphicon glyphicon-ok');
	}
	
	/* ::::::::: [ EMAIL PAIR CONFIRMATION END ] ::::::::: */
	/* ::::::::: [ EMAIL PAIR CONFIRMATION END ] ::::::::: */

	/* ::::::::: [ EMAIL BOUNCE BEGIN ] ::::::::: */
	/* ::::::::: [ EMAIL BOUNCE BEGIN ] ::::::::: */
	/* ::::::::: [ EMAIL BOUNCE BEGIN ] ::::::::: */

	/* ::::::::: [ EMAIL BOUNCE FEILD ONLY BEGIN ] ::::::::: */
	/* ::::::::: [ EMAIL BOUNCE FEILD ONLY BEGIN ] ::::::::: */
	$('.screenMailBounceInline').on("nb:result", function(event) {
			thisFocus = $(this).attr('id');
			setFocusUlc(thisFocus);
			screenMailBounceInline();
		});

	function screenMailBounceInline(){
		
		var nbFieldOk = validList[focusIndex];
		
		var ele = document.querySelector(focusId);
		var nbfields = _nb.fields.get(ele);
		if (Array.isArray(nbfields) && nbfields.length) {
			if (nbfields[0]._response && nbfields[0]._response.is(['valid', 'catchall', 'unknown'])) {
				nbFieldOk = true;
			} else {
				nbFieldOk = false;
			}
		}
		
		//if ( $(focusId).is(":valid") ) {
		if ( nbFieldOk == true ) {
			$(focusDiv).removeClass('has-error');
			$(focusSpan).removeClass('glyphicon glyphicon-remove');
			$(focusId).prop('aria-describedby', 'inputSuccess2Status');
			$(focusSpan).addClass('glyphicon glyphicon-ok');
			validList[focusIndex] = true;
		} else {
			$(focusDiv).addClass('has-error');
			$(focusId).prop('aria-describedby', 'inputError2Status');
			var errorNote = $(focusId).data('fail');
			$(focusId).attr("placeholder", errorNote)
			$(focusSpan).removeClass('glyphicon glyphicon-ok');
			$(focusSpan).addClass('glyphicon glyphicon-remove');
			validList[focusIndex] = false;
		}
		checkValid();
		
	}

	$('.screenMailBounceInline').on("input", function(event) {
		thisFocus = $(this).attr('id');
		setFocusUlc(thisFocus);
		validList[focusIndex] = false;
		screenMailBounceInlineUi();
	});
	
	function screenMailBounceInlineUi(){
		if ( $(focusId).is(":valid") ) {
			validList[focusIndex] = false;
		} else {
			$(focusDiv).addClass('has-error');
			$(focusId).prop('aria-describedby', 'inputError2Status');
			var errorNote = $(focusId).data('fail');
			$(focusId).attr("placeholder", errorNote)
			$(focusSpan).removeClass('glyphicon glyphicon-ok');
			$(focusSpan).addClass('glyphicon glyphicon-remove');
			validList[focusIndex] = false;
		}
		checkValid();
		
	}

	/* ::::::::: [ EMAIL BOUNCE FEILD ONLY END ] ::::::::: */
	/* ::::::::: [ EMAIL BOUNCE FEILD ONLY END ] ::::::::: */

	/* ::::::::: [ EMAIL BOUNCE FEILD W/ LABEL BEGIN ] ::::::::: */

	$('.screenMailBounceLabel').on("nb:result", function(event) {
		thisFocus = $(this).attr('id');
		setFocusUlc(thisFocus);
		screenMailBounceLabel();
	});

	function screenMailBounceLabel(){
		
		var nbFieldOk = validList[focusIndex];
		
		var ele = document.querySelector(focusId);
		var nbfields = _nb.fields.get(ele);
		if (Array.isArray(nbfields) && nbfields.length) {
			if (nbfields[0]._response && nbfields[0]._response.is(['valid', 'catchall', 'unknown'])) {
				nbFieldOk = true;
			} else {
				nbFieldOk = false;
			}
		}
		
		var labelTarget = $(focusId).data('label');
		var labelSuccess = $(focusId).data('success');
		var labelFail = $(focusId).data('fail');
		
		if ( nbFieldOk == true ) {
			$(focusDiv).removeClass('has-error');
			$(focusSpan).removeClass('glyphicon glyphicon-remove');
			$(focusId).prop('aria-describedby', 'inputSuccess2Status');
			$(focusSpan).addClass('glyphicon glyphicon-ok');
			$(labelTarget).html(labelSuccess);
			$(labelTarget).removeClass('text-danger'); // label change
			validList[focusIndex] = true;
		} else {
			$(focusDiv).addClass('has-error');
			$(focusId).prop('aria-describedby', 'inputError2Status');
			var errorNote = $(focusId).data('fail');
			$(focusId).attr("placeholder", errorNote)
			$(focusSpan).removeClass('glyphicon glyphicon-ok');
			$(focusSpan).addClass('glyphicon glyphicon-remove');
			$(labelTarget).html(labelFail)
			$(labelTarget).addClass('text-danger');
			validList[focusIndex] = false;
		}
		checkValid();
		
	}

	$('.screenMailBounceLabel').on("input", function(event) {
		thisFocus = $(this).attr('id');
		setFocusUlc(thisFocus);
		validList[focusIndex] = false;
		screenMailBounceLabelUi();
	});
	
	function screenMailBounceLabelUi(){
		
		var labelTarget = $(focusId).data('label');
		var labelSuccess = $(focusId).data('success');
		var labelFail = $(focusId).data('fail');
		
		if ( $(focusId).is(":valid") ) {
			validList[focusIndex] = false;
		} else {
			$(focusDiv).addClass('has-error');
			$(focusId).prop('aria-describedby', 'inputError2Status');
			var errorNote = $(focusId).data('fail');
			$(focusId).attr("placeholder", errorNote)
			$(focusSpan).removeClass('glyphicon glyphicon-ok');
			$(focusSpan).addClass('glyphicon glyphicon-remove');
			$(labelTarget).html(labelFail)
			$(labelTarget).addClass('text-danger');
			validList[focusIndex] = false;
		}
		checkValid();
		
	}

/* ::::::::: [ EMAIL BOUNCE PAIR BEGIN ] ::::::::: */
/* ::::::::: [ EMAIL BOUNCE PAIR BEGIN ] ::::::::: */

	$('.screenMailBouncePair').on("nb:result", function(event) {
			thisFocus = $(this).attr('id');
			setFocusUlc(thisFocus);
			emailPairIndex1 = $('#emailpair01').data("index");
			emailPairIndex2 = $('#emailpair02').data("index");
			screenMailBouncePair();
		});

	function screenMailBouncePair(){
		
		var nbFieldOk = validList[focusIndex];
		
		var ele = document.querySelector(focusId);
		var nbfields = _nb.fields.get(ele);
		if (Array.isArray(nbfields) && nbfields.length) {
			if (nbfields[0]._response && nbfields[0]._response.is(['valid', 'catchall', 'unknown'])) {
				nbFieldOk = true;
			} else {
				nbFieldOk = false;
			}
		}
		
		var mailValue00 = $('#emailpair01').val();
		var mailValue01 = $('#emailpair02').val();
		var mailValid00 = $('#emailpair01').is(":valid");
		var mailValid01 = $('#emailpair02').is(":valid");
		
		//if ( nbFieldOk == true ) {
		if(mailValue00 == mailValue01 && mailValid00 && nbFieldOk == true ){
			validList[emailPairIndex1] = nbFieldOk;
			validList[emailPairIndex2] = nbFieldOk;
			setFocus('emailpair01');
			emailPairSuccess();
			setFocus('emailpair02');
			emailPairSuccess();
		} //else {
		if(mailValue00 != mailValue01 || nbFieldOk != true ){
			validList[emailPairIndex1] = nbFieldOk;
			validList[emailPairIndex2] = nbFieldOk;
			setFocus('emailpair01');
			emailPairError()
			setFocus('emailpair02');
			emailPairError()
		}
		if(mailValue00 != mailValue01 && nbFieldOk == true ){ // new condition 050819
			if(focusIndex == emailPairIndex1 ){
				validList[emailPairIndex1] = false;
				validList[emailPairIndex2] = nbFieldOk;
			}
			if(focusIndex == emailPairIndex2 ){
				validList[emailPairIndex1] = nbFieldOk;
				validList[emailPairIndex2] = false;
			}
			setFocus('emailpair01');
			emailPairError()
			setFocus('emailpair02');
			emailPairError()
		}
		checkValid();
		
	}

	$('.screenMailBouncePair').on(pairEvent, function(event) {
		thisFocus = $(this).attr('id');
		setFocusUlc(thisFocus);
		emailPairIndex1 = $('#emailpair01').data("index");
		emailPairIndex2 = $('#emailpair02').data("index");
		screenEmailPair02();
	});

function screenEmailPair02(){
	// SCREEN #emailpair02 ON USER ENTRY DATA ...
		var mailValue00 = $('#emailpair01').val();
		var mailValue01 = $('#emailpair02').val();
		var mailValid00 = $('#emailpair01').is(":valid");
		var mailValid01 = $('#emailpair02').is(":valid");
		
		if(mailValue00 != mailValue01  ){
			//both valid, both match
			validList[emailPairIndex1] = false;
			validList[emailPairIndex2] = false;
			setFocus('emailpair01');
			emailPairError()
			setFocus('emailpair02');
			emailPairError()
		}
		
		checkValid();
}

/* ::::::::: [ EMAIL BOUNCE PAIR END ] ::::::::: */
/* ::::::::: [ EMAIL BOUNCE PAIR END ] ::::::::: */

	/* ::::::::: [ EMAIL BOUNCE END ] ::::::::: */
	/* ::::::::: [ EMAIL BOUNCE END ] ::::::::: */
	/* ::::::::: [ EMAIL BOUNCE END ] ::::::::: */

	
	/* :::::::::: [ TEXT AREA BEGIN ] :::::::::: */
	
	$('.screenTextArea').on("input", function(event) {
		thisFocus = $(this).attr('id');
		setFocus(thisFocus);
		screenTextArea();
	});
	
	function screenTextArea(){
		
		var minText = $(focusId).data("minimum");
		var thisMinimum = parseInt(minText);
		var thisLength = focusValue.length;
		
		if ( thisLength >= thisMinimum ) {
			$(focusDiv).removeClass('has-error');
			$(focusSpan).removeClass('glyphicon glyphicon-remove');
			$(focusId).prop('aria-describedby', 'inputSuccess2Status');
			$(focusSpan).addClass('glyphicon glyphicon-ok');
			validList[focusIndex] = true;
		} else {
			$(focusDiv).addClass('has-error');
			$(focusId).prop('aria-describedby', 'inputError2Status');
			var errorNote = $(focusId).data('fail');
			$(focusId).attr("placeholder", errorNote)
			$(focusSpan).removeClass('glyphicon glyphicon-ok');
			$(focusSpan).addClass('glyphicon glyphicon-remove');
			validList[focusIndex] = false;
		}
		checkValid();
		
	}
	
	/* :::::::::: [ TEXT AREA END ] :::::::::: */
	
	/* :::::::::: [ SELECT DROPDOWN BEGIN ] :::::::::: */
	/* :::::::::: [ SELECT DROPDOWN BEGIN ] :::::::::: */
	$('.screenSelect').change(function () {
		thisFocus = $(this).attr('id');
		setFocus(thisFocus);
		screenSelect();
	});
	
	function screenSelect(){
		var thisId = "#" + thisFocus;
		var optionIndex = $(thisId)[0].selectedIndex;
		var isRequired = $(thisId).prop('required');

		if ( optionIndex > 0 && isRequired ) {
			validList[focusIndex] = true;
		}
		if ( optionIndex == 0 && isRequired ) {
			validList[focusIndex] = false;
		}
		checkValid();

	}
	/* :::::::::: [ SELECT DROPDOWN END ] :::::::::: */
	/* :::::::::: [ SELECT DROPDOWN END ] :::::::::: */

		/* :::::::::: [ SELECT FILTER DROPDOWN BEGIN ] :::::::::: */
	/* :::::::::: [ SELECT FILTER DROPDOWN BEGIN ] :::::::::: */

	// CHAIN SELECT VARs...
	var chainFocusId = ""; // id in use
	var chainFocusIndex = ""; // index of ID in use, within group
	var chainClassName = ""; // class in use no period 'class-name'
	var chainFocusClass = ""; // class in use with period '.class-name'
	var chainCleanMatch = true;
	
	var chainFocusTh;  // th (label) for feedback
	var chainSuccess;  // th (label) for feedback
	var chainError;
	
	var chainIdList = []; //  "#groupname-z-0-0", "#groupname-z-0-1", "#groupname-z-0-2", collected list of IDs
	var chainOptIndexList = []; // 1,0,0, collected list of option Index Selections
	var chainValueList = []; // "no_selection-0-0", "Option A", "Option B", collected list of Text Values
	var chainOptionClassList = []; //  ".no_selection-0-0", ".option-a", ".option-b", collected list of option classes
	var chainIndexList = []; //  0, 1, 2,   collected INDEX list for FORM VALIDATION POSITION
	var blockIndexList = []; // 0,1,2, INDEX IN BLOCK-GROUP (EQUAL OR LOWER THAN focusIndex)
	var allOptionClassList = []; // list of all available opitons

	$('.screenSelectFilter').change(function () {
		thisFocus = $(this).attr('id');
		setFocus(thisFocus);
		
		/* :::::::::: [ FILTER CHAIN START ] :::::::::: */
		/* :::::::::: [ FILTER CHAIN START ] :::::::::: */
		
		var thisTarget = thisFocus; //id of select
		var targetGroup = $(this).data("group");  // data target for selected
		chainFocusClass = ".select-chain-" + targetGroup; 
		chainClassName = "select-chain-" + targetGroup; 
		
		chainIdList = []; // RESET IDs to Target
		chainOptIndexList = []; // RESET CURRENT OPTION INDEX LIST
		chainValueList = []; // RESET CURRENT VALUE LIST
		chainOptionClassList = []; // RESET OPTION CLASS LIST
		chainIndexList = []; // RESET SELECT INDEX
		allOptionClassList = []; // RESET LIST OF AVAILABLE OPTIONS
		blockIndexList = []; // INDEX IN BLOCK-GROUP (EQUAL OR LOWER THAN focusIndex)
		
		chainFocusTh = $(this).data("th"); // error feedback th (not label)
		chainSuccess = $(this).data("success");
		chainError = $(this).data("fail");
		
		chainFocusId = "#" + thisTarget;
		chainFocusIndex = $(this).data("index");  // focus index within group
		
		// get all IDs IN THIS BLOCK
		$(chainFocusClass).each(function () {
			chainIdList.push("#" + this.id);
			blockIndexList.push(blockIndexList.length);
		});
				
		// get all OPTION CLASSES IN THIS BLOCK
		var thisOptionSet = chainFocusId + " option"; // '#select-id option'
		$(thisOptionSet ).each(function () {
			var thisOptionValue = $(this).val();
			var thisOptionFilter = "." + thisOptionValue.replace(/\s+/g, '-').toLowerCase();
			allOptionClassList.push(thisOptionFilter);
		});
		
		allOptionClassList.shift(); // delete first default option from list
		
		for (i = 0; i < chainIdList.length; i++) { 
			chainOptIndexList.push( $(chainIdList[i])[0].selectedIndex );
			var valueSource = $(chainIdList[i]).val();
			chainValueList.push( $(chainIdList[i]).val() );
			var optionTarget = "." + valueSource.replace(/\s+/g, '-').toLowerCase();
			chainOptionClassList.push(optionTarget);
			chainIndexList.push( $(chainIdList[i]).data("index") )
		}
		
		filterSelectChain();
	});

	function filterSelectChain(){
		
		chainCleanMatch = true;
				
		// RESET OTHER SELECTS IN CHAIN, IF SAME VALUE...
		for (i = 0; i < chainIdList.length; i++) { 
			
			var firstIndex = chainOptIndexList.indexOf(chainOptIndexList[i]); // finds first occurence of option index
			var lastIndex = chainOptIndexList.lastIndexOf(chainOptIndexList[i]); // finds last occurence of option index
			
			if(chainOptIndexList[firstIndex] == chainOptIndexList[lastIndex] && lastIndex != firstIndex && chainOptIndexList[firstIndex] != 0){
				// if 1st option index equals(matches) last option index, & the first and last matching indexes are in different spots, & index is not 0 
				$(chainIdList[lastIndex]).prop('selectedIndex', 0); 


				chainOptIndexList[i] = 0; // set index option to 0
				chainCleanMatch = false;
			} // end if match check
		} // end for loop
		
		// RESET ALL OPTIONS UNDER THIS .block-class
		var thisBlockOption = chainFocusClass + " option"; // .block-class option
		$(thisBlockOption).show();
		
		for (i = 0; i < chainIdList.length; i++) { 

					for (j = 0; j < chainOptionClassList.length; j++) { 
						var thisOption = chainIdList[i] + " " + chainOptionClassList[j];
						var optionIndexOf = chainOptionClassList[j].indexOf(".no_selection");
						
						if(optionIndexOf == -1 && j < blockIndexList[i] && optionIndexOf == -1  ){
							$(thisOption).hide();
						}
					} // end j loop
				
		} // end loop i
		
		// check to see any options are still at default
		var indexOfZero = chainOptIndexList.indexOf(0);
		if(indexOfZero > -1){
			chainCleanMatch = false;
		}
		
		doSelectChainFeedback();
		
	}

	  function doSelectChainFeedback(){
		  
		  var isRequired = $(chainFocusId).prop('required'); // chainFocusId

		  if(chainCleanMatch == true){
			  $(chainFocusTh).html(chainSuccess);
			  $(chainFocusTh).removeClass('text-danger');
		  } else {
			  $(chainFocusTh).html(chainError);
			  $(chainFocusTh).addClass('text-danger');
		  }

		 // SET VALIDATION FOR SELECT
		  for (i = 0; i < chainOptIndexList.length; i++) { 
			  // GET INDEX OF SELECTED OPTION FOR VALIDATION...
			  var targetIndex = chainIndexList[i];
			  if(chainOptIndexList[i] > 0  && isRequired){
				  validList[targetIndex] = true;
			  } 
			  if(chainOptIndexList[i] == 0  && isRequired){
				 validList[targetIndex] = false; 
			  }
		  }
		  
		  checkValid();

	  }


	/* :::::::::: [ SELECT FILTER DROPDOWN END ] :::::::::: */
	/* :::::::::: [ SELECT FILTER DROPDOWN END ] :::::::::: */

	$('.screenSelectLabelRow').change(function () {
		//console.log("screenSelectLabelRow");
		thisFocus = $(this).attr('id');
		setFocus(thisFocus);
		screenSelectLabelRow();
	});
	
	function screenSelectLabelRow(){
		var thisId = "#" + thisFocus;
		var optionIndex = $(thisId)[0].selectedIndex;
		var isRequired = $(thisId).prop('required');
		
		var thisSuccess = $(thisId).data("success");
		var thisFail = $(thisId).data("fail");
		
		var groupName = Number( $(thisId).data("group") );
		var thisClass = ".select-chain-" + groupName;
		var thTarget = $(thisId).data("th");
		
		var indexCount = -1;
		var selectCount = -1
		
		$( thisClass ).each(function() {
			var thisIndex = $( this)[0].selectedIndex;
			if(thisIndex > 0){indexCount += 1}
			selectCount +=1;
		});
		
		if(indexCount != selectCount && isRequired){
			$(thTarget).html(thisFail);
			$(thTarget).addClass('text-danger');
		} else {
			$(thTarget).html(thisSuccess);
			$(thTarget).removeClass('text-danger')
		}

		if ( optionIndex > 0 && isRequired) {
			validList[focusIndex] = true;
		}
		if ( optionIndex == 0 && isRequired) {
			validList[focusIndex] = false;
		}
		checkValid();

	}
	
	/* :::::::::: [ CHECKBOX SCREEN BEGIN ] :::::::::: */
	/* :::::::::: [ CHECKBOX SCREEN BEGIN ] :::::::::: */
	$('.screenCheckbox').change(function () {
		thisFocus = $(this).attr('id');
		setFocus(thisFocus);
		screenCheckbox();
	});
	
	function screenCheckbox(){
		var boxChecked = $( focusId )[0].checked; //gives true or false
		var checkRequired = $( focusId ).prop('required');
		var dataSuccess = $( focusId ).data("success");
		var dataFail = $( focusId ).data("fail"); 
		if(boxChecked == true && checkRequired){
			$(focusSpan).html(dataSuccess);
			$(focusSpan).removeClass('text-danger');
			validList[focusIndex] = true;
		}
		if (boxChecked == false && checkRequired){
			$(focusSpan).html(dataFail);
			$(focusSpan).addClass('text-danger');
			validList[focusIndex] = false;
		};
		
		if(boxChecked == true){
			$( focusId ).val(true);
		} else {
			$( focusId ).val(false);
		}
		
		checkValid();
		
	}
	/* :::::::::: [ CHECKBOX SCREEN END ] :::::::::: */
	/* :::::::::: [ CHECKBOX SCREEN END ] :::::::::: */

	/* :::::::::: [ CHECKBOX GROUP SCREEN BEGIN ] :::::::::: */
	/* :::::::::: [ CHECKBOX GROUP SCREEN BEGIN ] :::::::::: */
	$('.screenCheckGroup').change(function () {
		thisFocus = $(this).attr('id');
		setFocus(thisFocus);
		screenCheckGroup();
	});
	
	function screenCheckGroup(){
		var boxChecked = $( focusId )[0].checked; //gives true or false
		var checkRequired = $( focusId ).data("required") // $( focusId ).prop('required');
		var dataSuccess = $( focusId ).data("success");
		var dataFail = $( focusId ).data("fail"); 
		var dataId = $( focusId ).data("index");
		//alert(checkRequired)
		if(boxChecked == true && checkRequired == true){
			$(focusSpan).html(dataSuccess);
			$(focusSpan).removeClass('text-danger');
			//validList[focusIndex] = true;
		}
		if (boxChecked == false && checkRequired == true){
			$(focusSpan).html(dataFail);
			$(focusSpan).addClass('text-danger');
			//validList[focusIndex] = false;
		};
		
		var checkList = [];
		var thisGroup = ".checkGroup-" + focusIndex + ":checked";
		$(thisGroup).each(function() {
			checkList.push(true);
			//console.log(focusId + " | " +checkList);
		});
		var isCheck = checkList.indexOf(true);
		if(isCheck > -1){
			validList[focusIndex] = true;
		} else {
			validList[focusIndex] = false;
		}
		
		if(checkRequired == false){
			validList[focusIndex] = true;
		}
		
		
		checkValid();
		
	}
	/* :::::::::: [ CHECKBOX GROUP END ] :::::::::: */
	/* :::::::::: [ CHECKBOX GROUP END ] :::::::::: */
	
	/* :::::::::: [ RULES CHECKBOX SCREEN BEGIN ] :::::::::: */
	/* :::::::::: [ RULES CHECKBOX SCREEN BEGIN ] :::::::::: */
	$('.screenCheckRules').change(function () {
		thisFocus = $(this).attr('id');
		setFocus(thisFocus);
		screenCheckRules();
	});
	
	function screenCheckRules(){
		//DATA-TARGETS IN CHECKBOX
		var boxChecked = $( focusId )[0].checked; //gives true or false
		var checkRequired = $( focusId ).prop('required');
		
		if(boxChecked == true && checkRequired){
			$(focusSpan).removeClass('text-danger');
			validList[focusIndex] = true;
			$( focusId ).val(true);
		}
		if (boxChecked == false && checkRequired){
			$(focusSpan).addClass('text-danger');
			validList[focusIndex] = false;
			$( focusId ).val(true);
		};
		
		if(boxChecked == true){
			$( focusId ).val(true);
		} else {
			$( focusId ).val(false);
		}
		
		checkValid();
		
	}
	/* :::::::::: [ RULES CHECKBOX SCREEN END ] :::::::::: */
	/* :::::::::: [ RULES CHECKBOX SCREEN END ] :::::::::: */
	
	/* :::::::::: [ RADIO SCREEN BEGIN ] :::::::::: */
	/* :::::::::: [ RADIO SCREEN BEGIN ] :::::::::: */
	$('.screenRadio').change(function () {
		thisFocus = $(this).attr('id');
		setFocus(thisFocus);
		screenRadio();
		
	});
	
	function screenRadio(){
		var thisIndex = $( focusId ).data("index");
		var thisGroup = "radioGroup" + thisIndex;
		var thisChecked = focusId + ":checked";
		
		if( $(thisChecked) ){
			validList[focusIndex] = true;
			//console.log(focusId + " checked | " + focusIndex + " | " + validList[focusIndex] );
		}
		checkValid();
	}
	
	/* :::::::::: [ RADIO SCREEN END ] :::::::::: */
	/* :::::::::: [ RADIO SCREEN END ] :::::::::: */

	/* :::::::::: [ INPUT RETURN SCREEN START ] :::::::::: */
	/* :::::::::: [ INPUT RETURN SCREEN START ] :::::::::: */

	$('.screenNoReturnKey').keypress(function(e){
		if ( e.which == 13 ){
			return false; // e.preventDefault();
		} 
	});

	/* :::::::::: [ INPUT RETURN SCREEN END ] :::::::::: */
	/* :::::::::: [ INPUT RETURN SCREEN END ] :::::::::: */
	
	/* :::::::::: [ SCREEN CAPTCHA BEGIN ] :::::::::: */
	/* :::::::::: [ SCREEN CAPTCHA BEGIN ] :::::::::: */
	
	function screenCaptcha(){
		var sourceIndex = $('#captchaElement').data('index');
		var thisIndex = parseInt(sourceIndex);
		if(grecaptcha.getResponse() != ""){
			validList[thisIndex] = true;
		}	
		checkValid();
	}
	
	/* :::::::::: [ SCREEN CAPTCHA END ] :::::::::: */
	/* :::::::::: [ SCREEN CAPTCHA END ] :::::::::: */

/*
function ulcFilter(){
	var thisValue = focusValue;
	var filterType = $(focusId).data("ulc");
	
		switch(filterType) {
			case "uppercase":
				thisValue = focusValue.toUpperCase();
				$(focusId).val(thisValue);
				break;
			case "lowercase":
				thisValue = focusValue.toLowerCase();
				$(focusId).val(thisValue);
				break;
			case "mixedcase":
				thisValue = filterCaptilaize(focusValue);
				$(focusId).val(thisValue);
				break;
			default:
				thisValue = thisValue; // user, collapse, or Nan
		}
	
	console.log("ulcFilter = " + focusId + ":" + filterType + ":" + thisValue );
	
}
*/

function filterCaptilaize( str ){
    var wordList = str.split(" ");
    for ( var i = 0; i < wordList.length; i++ ){
        var j = wordList[i].charAt(0).toUpperCase();
        wordList[i] = j + wordList[i].substr(1).toLowerCase();
    }
    return wordList.join(" ");
}
	
	/* :::::::::: [ SCREENING FUNCTIONS END ] :::::::::: */
	/* :::::::::: [ SCREENING FUNCTIONS END ] :::::::::: */
	
	/* :::::::::: [ VALIDATION BEGIN ] :::::::::: */
	/* :::::::::: [ VALIDATION BEGIN ] :::::::::: */
	
	function checkValid(){
		var thisScore = 0;
		
		for (i = 0; i < validList.length; i++) { 
			if(validList[i] == true){thisScore += 1}
		}
		
		//feedback for button id = #button-submit
		var thisButtonId = "#button-submit";
		var dataSuccess = $("#button-submit").data("success"); 
		var dataFail = $("#button-submit").data("fail"); 
		
		// feedback for custom url button id = #button-url
		if( $('#button-url').length ){
			thisButtonId = "#button-url";
			dataSuccess = $("#button-url").data("success"); 
			dataFail = $("#button-url").data("fail"); 
		}
		
		if(thisScore == validList.length){
			$(thisButtonId).removeAttr("disabled");
			$(thisButtonId).removeClass("disabled");
			$(thisButtonId).html(bntValidIcon + dataSuccess);
		} else {
			$(thisButtonId).attr("disabled", "disabled");
			$(thisButtonId).addClass("disabled");
			$(thisButtonId).html(dataFail);
		}
		
		if(playeIdTarget.length > 1){
			var thisValue = $(playeIdTarget).val();
			var thisPlayerElement = "#" + playerIdTag;
			$(thisPlayerElement).val(thisValue); // add player-id target text to input
		}
		
		//console.log("thisScore: " + thisScore + " validList-length:" + validList.length);
		//console.log(validList);
		
	}
	
	/* :::::::::: [ VALIDATION END ] :::::::::: */
	/* :::::::::: [ VALIDATION END ] :::::::::: */
	
/* ::::::::::: [ RULE-PRIVACY POP-UP MODAL START ] :::::::::: */
/* ::::::::::: [ RULE-PRIVACY POP-UP MODAL START ] :::::::::: */

var termsPopUp = false;
	
	$(".rulesPopUp").click(function(){
	  var thisLink = exitlinks[0].rules;
	  termsPopUp = true;
	  $("#termsIframe").attr("src", thisLink);
	  sizeRuleFrame();
	  $( "#termsDiv" ).show();
	});
	
	$(".privacyPopUp").click(function(){
	  var thisLink = exitlinks[0].privacy;
	  termsPopUp = true;
	  $("#termsIframe").attr("src", thisLink);
	  sizeRuleFrame();
	  $( "#termsDiv" ).show();
	});
	
	$("#btnCloseTerms").click(function(){
	  $( "#termsDiv" ).hide();
	});
	
	$( window ).resize(function() {
	  if(termsPopUp == true){
	  	sizeRuleFrame();
	  }
	});
	
	function sizeRuleFrame(){
		var thisHeight = Math.round( $(window).height() * .8 );
		var thisWidth = Math.round( $(window).width() * .8 );
		
		if(thisWidth > 640){thisWidth = 640};
		
		$('#termsDiv').height(thisHeight);
		$('#termsDiv').width(thisWidth);
		
		var frameHeight = thisHeight - 18;
		$('#termsIframe').height(frameHeight);
		$('#termsIframe').width(thisWidth);
		
	}
	
	/* :::::::::: [ RULES-PRIVACY POP-UP END ] ::::::::::: */
	/* :::::::::: [ RULES-PRIVACY POP-UP END ] ::::::::::: */
	
	/* :::::::::: [ BUTTON CLICK THRU BEGIN ] :::::::::: */
	/* :::::::::: [ BUTTON CLICK THRU BEGIN ] :::::::::: */
	
		$(".button-enter").click(function(){
		  //closeEntryUi();  // see form_style.js
			
			if($("#button-submit").attr('disabled')){
				 console.log("button disabled");
			  }else{
				  closeEntryUi()
			  }
			
		});
		
		$("#demoBtn").click(function(){
		  closeEntryUi();   // see form_style.js
		});
		
		/*$(".button-exit").click(function(){
		  alert("button form exit click");
		});*/
		
		$(".button-goback").click(function(){
		  if(window.history.length > 1){
					window.history.go(-1);
				} else{
					window.close();
			} //end if
		});

		$(".button-exitlink").click(function(){
		  var thisLink = $('#button-exitlink').data("url");
		  window.location.href = thisLink; //with browser history
		});

		$(".button-url").click(function(){
		  runAjaxUrl();
		});
	
	/* :::::::::: [ BUTTON CLICK THRU END ] :::::::::: */
	/* :::::::::: [ BUTTON CLICK THRU END ] :::::::::: */
